var Dfe47000_LiberacaoParaFinanceiro_Controller = function(General, ScreenService, localStorageEngine,MessageService, ZhFilterPreferences, templateManager,AprovacaoLancamentos_Service,ErrosCancelamentoAprovacaoLancamentos_Utilities,contabilizacaoController) {
    
    var messages = {};
    
    var self = this;
    
    this.setFilterOnEnterOnce = function(args) {
        let widget = args.owner;
        if (sessionStorage.getItem('CDEMPRESA') &&  sessionStorage.getItem('NMEMPRESA') && sessionStorage.getItem('DTEMISSAO')){
            this.blockFieldsFilhosAndSetEvents(widget, true, undefined , false);
            this.filtroPainelDeControle(args);
            sessionStorage.clear();
        }else{
            General.callRestEngine("df_entrada#/getFilter_Liberacao", "FilterData", []).then((success) => {
                var filterDefault = success.dataset.filter_liberacao;
                var row = Util.clone(widget.currentRow);
                for(var key in filterDefault) {
                    row[key] = filterDefault[key];
                }
                this.blockFieldsFilhosAndSetEvents(widget, true, row , true );
            },
            (error) => {
                this.blockFieldsFilhosAndSetEvents(widget, true, true );
            });
        }
    };
    
    this.setStripeData = function(widget) {
        var currentRow = widget.appliedFilter.FILTER_ROW;
        var stripeWidget = templateManager.container.getWidget("liberacaoFinanceiroStripe");
        var notas = templateManager.container.getWidget("wdg_liberacaoParaFinanceiro").dataSource.data;
        //let totalOriginal   = 0;

        stripeWidget.currentRow = {};
        stripeWidget.currentRow.NMEMPRESA   = currentRow.CDEMPRESA + ' - ' + currentRow.NMEMPRESA;
         
        /*notas.forEach(function(nota){
            totalOriginal += self.formataValor(nota.VRNOTAFISC); 
        });*/
        
        //stripeWidget.currentRow.NRTOTNOTAFISC   = this.numberToReal(totalOriginal);
    };
    
    this.setValuesFooter = function(widget) {
        var currentRow = templateManager.container.getWidget("wdg_liberacaoParaFinanceiro").currentRow;
        var stripeWidget = templateManager.container.getWidget("stripeFooter");

        stripeWidget.currentRow = {};
        stripeWidget.currentRow.VRNOTAFISC   = this.numberToReal(currentRow.VRNOTAFISC);
        stripeWidget.currentRow.NRNOTAFISC   = currentRow.NRNOTAFISC;
        
        widget.unSelectAll();
        widget.reload();
    };
    
    this.atualizaDataSourceCP = function(){
        var widget = templateManager.container.getWidget("wdg_vencimentos");
        if(widget){
            var contas = widget.dataSource.data;
            
            contas.forEach(function(conta){
                if(conta.IDBLOQNFFINCP == null){
                    conta.IDBLOQNFFINCP = 'B';
                }
            });
            
            widget.dataSource.data = contas;
        }
        
    };
    
    
    //Liberação para financeiro
    this.setStripe = function() {
        let widget          = templateManager.container.getWidget("wdg_liberacaoParaFinanceiro");
        let stripeWidget    = templateManager.container.getWidget("liberacaoFinanceiroStripe");
        let checkedRows     = widget.getCheckedRows();
        let totalOriginal   = 0;
        
        checkedRows.forEach(function(item){
            totalOriginal += self.formataValor(item.VRNOTAFISC);
        });
        
       
        stripeWidget.currentRow.VRCONTPGS = this.numberToReal(totalOriginal);
        
    };
    
    this.unsetStripeData = function() {
         let widget          = templateManager.container.getWidget("wdg_liberacaoParaFinanceiro");
        let stripeWidget    = templateManager.container.getWidget("liberacaoFinanceiroStripe");
        let checkedRows     = widget.getCheckedRows();
        let totalOriginal   = 0;
        
        if(checkedRows.length > 0){
            checkedRows.forEach(function(item){
                totalOriginal += self.formataValor(item.VRNOTAFISC);
            });
        }
        stripeWidget.currentRow.VRCONTPGS = self.numberToReal(totalOriginal);
        
    };
    
    this.setStripeFooter = function(widgetCP) {
        //et widgetCP          = args.owner.widget;
        let stripeWidget    = templateManager.container.getWidget("stripeFooter");
        let checkedFooter     = widgetCP.getCheckedRows();
        let totalOriginal   = 0;
        
        checkedFooter.forEach(function(item){
            totalOriginal += self.formataValor(item.VRORIGPAG);
        });
        
       
        stripeWidget.currentRow.VRTOTPAG = this.numberToReal(totalOriginal);
        
    };
    
    this.unsetStripeDataFooter = function(widgetCP) {
        let stripeWidget    = templateManager.container.getWidget("stripeFooter");
        let totalOriginal   = 0;
        if(widgetCP){
            let checked     = widgetCP.getCheckedRows();
    
            if(checked.length > 0){
                checked.forEach(function(item){
                    totalOriginal += self.formataValor(item.VRORIGPAG);
                });
            }
        }
        stripeWidget.currentRow.VRTOTPAG = self.numberToReal(totalOriginal); 
    };
    
    /*this.setDataSource = function(widget){
        
        var widgetLiberacao = templateManager.container.getWidget('wdg_liberacaoParaFinanceiro');
        
        var notas = widgetLiberacao.dataSource.data;
        notas.forEach(function(nota){
            var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": nota.CDFILIAL
                },
                {
                    "name": "NRLANCTONF",
                    "operator": "=",
                    "value": nota.NRLANCTONF
                }
            ];
            nota.FORAORCAMENTO = false;
            General.callRestEngine("df#/crud/contapagar",'FilterData', filter).then(function(success) {
                if(success.dataset.contapagar[0]){
                    nota.DTATUAVENPAG = success.dataset.contapagar[0].DTATUAVENPAG;
                    nota.DSCONTAPAG = success.dataset.contapagar[0].DSCONTAPAG;
                    nota.QTDVENCIMENTOS = success.dataset.contapagar.length;
                }
            });
        });
        widgetLiberacao.dataSource.data = notas;
    };*/
    
    this.numberToReal = function(numero) {
        numero = parseFloat(numero).toFixed(2).split('.');
        numero[0] = numero[0].split(/(?=(?:...)*$)/).join('.');
        return numero.join(',');
    };
    
    this.formataValor = function(valor){
        if(typeof valor == 'string')
            if(valor.indexOf(',') >= 0)
                valor = valor.replace('.','').replace(',','.');
                
        valor = parseFloat(parseFloat(valor).toFixed(2));

        return valor;
    };
    
    var concatenaFields = function(selectField, currentRow) {
		var lista;
		if (!currentRow) {
		   return 'T'; 
		}
		if (Array.isArray(currentRow)) {
		   lista = '_' + currentRow.join('_') + '_';
		}   
		return lista;
	};
     
    
    this.preparaFiltro = function(args) {
        args.e.preventDefault();
        var widget = args.owner;
    
        if(widget.appliedFilter) {
            args.e.filters.forEach((f) => {
                
                if(f.name == "NMTIPOOPER") widget.appliedFilter.FILTER_ROW.CDTIPOOPER = concatenaFields(widget.getField('NMTIPOOPER'), widget.appliedFilter.FILTER_ROW.CDTIPOOPER);
                else if(f.name == "DSSERIEENTR") widget.appliedFilter.FILTER_ROW.CDSERIEENTR = concatenaFields(widget.getField('DSSERIEENTR'), widget.appliedFilter.FILTER_ROW.CDSERIEENTR);
                else if(f.name == "NMFILIORIG") widget.appliedFilter.FILTER_ROW.CDFILIORIG = concatenaFields(widget.getField('NMFILIORIG'), widget.appliedFilter.FILTER_ROW.CDFILIORIG);
                else if(f.name == "DSBLOQNFFIN") f.value = widget.appliedFilter.FILTER_ROW.IDBLOQNFFIN;
            });      
        }
        widget.dataSourceFilter.push({"name": "CDTIPOOPER", "operator": "=" , "value": widget.appliedFilter.FILTER_ROW.CDTIPOOPER || 'T'});
        widget.dataSourceFilter.push({"name": "CDSERIEENTR", "operator": "=" , "value": widget.appliedFilter.FILTER_ROW.CDSERIEENTR || 'T'});
        widget.dataSourceFilter.push({"name": "CDFILIORIG", "operator": "=" , "value": widget.appliedFilter.FILTER_ROW.CDFILIORIG || 'T'});
        
        widget.reload();
    };
    
    
    this.inicializaAnexoLiberaLanc = function(args){
        var filter = [
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": args.owner.getParent().currentRow.CDFILIAL
            },
            {
                "name": "P_NRLANCTONF",
                "operator": "=",
                "value": args.owner.getParent().currentRow.NRLANCTONF
            }
            
        ];

        General.callRestEngine("df#/crud/anexo_obrigatorio", "FilterData", filter).then((success) => {
            if(success.dataset.anexo_obrigatorio[0].IDBLOQANEXO) {
                if(success.dataset.anexo_obrigatorio[0].IDBLOQANEXO == 0) {
                    args.owner.getAction("actNovoAnexo").isVisible = false;
                    args.owner.getAction("actDeleteAnexo").isVisible = false;
                }
                else if(success.dataset.anexo_obrigatorio[0].IDBLOQANEXO == 1 && args.owner.getParent().currentRow.IDSTATUS == 'A') {
                    args.owner.getAction("actNovoAnexo").isVisible = false;     
                    args.owner.getAction("actDeleteAnexo").isVisible = false;
                }                
                else if(success.dataset.anexo_obrigatorio[0].IDBLOQANEXO == 2 && (args.owner.getParent().currentRow.IDBLOQNFFIN == 'L')) {
                    args.owner.getAction("actNovoAnexo").isVisible = false;     
                    args.owner.getAction("actDeleteAnexo").isVisible = false;
                }
                else {
                    args.owner.getAction("actNovoAnexo").isVisible = true;    
                    args.owner.getAction("actDeleteAnexo").isVisible = true;
                }
            }
        });
        args.owner.reload();
    };
    
    this.alteraReadOnlyFilhos = function(field) {
        let widget = field.widget;
        field.filhos.forEach((filho) => {
            var desbloqueiaComValor = (filho.desbloqueiaComValor) ? filho.desbloqueiaComValor : true;
            var valueDesbloqueia    = (filho.valueDesbloqueia)    ? filho.valueDesbloqueia    : null;
            var isRequired          = (filho.isRequired)          ? filho.isRequired          : false;
            
            let filhoField = widget.getField(filho.name);
            
            
            if(valueDesbloqueia == null) {
                filhoField.readOnly =  ((field.value() == "") == desbloqueiaComValor);
                if(((field.value() == "") == desbloqueiaComValor)) widget.currentRow[filho.name] = "";
                if(filhoField.filhos) this.alteraReadOnlyFilhos(filhoField, true);
                widget.getField(filho.name).reload();
            }
            else {
                var habilita = (field.value() == valueDesbloqueia);
                if(habilita) {
                    if(filhoField.readOnly) {
                        if(filho.clearFields) {
                            filho.clearFields.forEach((clearField) => {
                                widget.currentRow[clearField] = "";
                            });
                        }
                        widget.currentRow[filho.name] = "";
                    }
                    
                    filhoField.readOnly = false;
                    
                    if(isRequired) {
                        if(filhoField.validations) {
                            filhoField.validations.required = true;
                        }
                        else {
                            filhoField.validations = {required : true};
                        }
                    }
                }
                else {
                    var filhoOutData = filhoField.outData;
                    for(var fieldOut in filhoOutData) {
                        widget.currentRow[fieldOut] = "";
                    } 
                    widget.currentRow[filho.name] = "";
                    filhoField.readOnly = true;
                    if(isRequired) {
                        if(filhoField.validations) {
                            if(filhoField.validations.required) delete filhoField.validations.required;
                        }
                    }
                }
                if(filhoField.filhos) this.alteraReadOnlyFilhos(filhoField, true);
            }
        });
    };

    /*
        Percorre uma widget procurando por fields com a propiedade "filhos".
        Para os fields com a propiedade fields a função adiciona o evento 
        de alteraReadOnlyFilhos.
        
        @param widget widget
        @param boolean filter
    */
    this.blockFieldsFilhosAndSetEvents = function(widget, filter, row, filtrarPeloDashboard) {
        let fields = widget.fields;
        fields.forEach((field) => {
            if(field.filhos) {
                field.events.push(
                    {
                        "name": "FieldOnChange",
                        "code": "Dfe47000_LiberacaoParaFinanceiro_Controller.alteraReadOnlyFilhos(args.owner.field)"
                    }
                );
                
                field.filhos.forEach((filho) => {
                    if(filter) {
                        if(!widget.getField(filho.name).filterProperties) 
                            widget.getField(filho.name).filterProperties = {};
                        
                        widget.getField(filho.name).filterProperties.readOnly = true; 
                    }
                    else  widget.getField(filho.name).readOnly = true; 
                });
            }
        });
        if(row && filtrarPeloDashboard) {
            ZhFilterPreferences.setOriginalFilter(widget.id, row);
            ZhFilterPreferences.openFilterWidget(widget, row);
        }
        else if (filtrarPeloDashboard){ ZhFilterPreferences.openFilterWidget(widget);}
    };
    
    /*
    * Processos
    **/
    
    this.consultaContabilizacao = function(widget){
        var checkedrows = widget.getCheckedRows();

        if(checkedrows.length > 0) {
            var contabil = [];
            var contctb = 0;

            for (var i = 0; i < checkedrows.length; i++){
                if (checkedrows[i].NRLANCTBDOC) {
                    contabil.push({});
                    contabil[contctb].CDEMPRESA  = checkedrows[i].CDEMPRESA;
                    contabil[contctb].NRLANCCONT = checkedrows[i].NRLANCTBDOC;
                    contctb++;
                }
            }
            if(contabil.length > 0) {
                contabilizacaoController.exibeContabilizacao(contabil);
            }else ScreenService.showMessage('Título(s) marcado(s) não possui(em) contabilização(ões).');
        }else ScreenService.showMessage('Marque o(s) título(s) para consulta da(s) contabilização(ões).');
     };
    
    this.setAprovacaoLiberacao = function(widget, mode) {
        var rows = widget.getCheckedRows();
        if(rows)  {
            if(mode == 'L'){
                General.callRestEngine("df_entrada#/liberarTitulos", "DataSet", rows).then((result) => {
                var titulosLiberados = "TITULOS_LIBERADOS";
                ScreenService.closePopup();
                if(result.dataset.erros_aprovacao[0]) {
                    if(rows.length != result.dataset.erros_aprovacao.length) {
                        ScreenService.successNotification(result.messages[0].message);
                    }
                    this.openPopupErros(result.dataset.erros_aprovacao);
                }
                else {
                    if(result.messages[0].message == "Nenhum dos titulos selecionados pode ser liberado."){
                        ScreenService.showMessage("Nenhum dos titulos selecionados pode ser liberado.");
                    }else{
                    MessageService.successNotificationByCode(titulosLiberados, null, {"NUMTITULOS": result.messages[0].message});
                    }
                }
                widget.reload();
            }, (error) => ScreenService.errorNotification(error));

            }else{
                General.callRestEngine("df_entrada#/bloquearTitulos", "DataSet", rows).then((result) => {
                var titulosBloqueados = "TITULOS_BLOQUEADOS";
                ScreenService.closePopup();
                if(result.dataset.erros_aprovacao[0]) {
                    if(rows.length != result.dataset.erros_aprovacao.length) {
                        ScreenService.successNotification(result.messages[0].message);
                    }
                    this.openPopupErros(result.dataset.erros_aprovacao);
                }
                else {
                    if(result.messages[0].message == "Nenhum dos titulos selecionados pode ser bloqueado."){
                        ScreenService.showMessage("Nenhum dos titulos selecionados pode ser bloqueado.");
                    }else{
                        MessageService.successNotificationByCode(titulosBloqueados, null,{"NUMTITULOS": result.messages[0].message});                        
                    }
                }
                widget.reload();
            }, (error) => ScreenService.errorNotification(error));

            }
        }
        else {
            ScreenService.showMessage("Nenhum titulo foi selecionado.");
        }
    };
    
    this.openPopup = function(widget){
        
        var notasMarcadas = widget.getCheckedRows();
        var notas = notasMarcadas.filter(function(notafiscal){
            return notafiscal.IDSTATUS === "A" && notafiscal.IDBLOQNFFIN == "B";
        });
        
        if(notas.length > 0){
            ScreenService.openPopup(templateManager.container.getWidget("justificativaRecusa"));
        }else{
            ScreenService.showMessage("Nenhuma nota bloqueada foi marcada! ");
        }
        
    };
    
    //FUNÇÃO PARA VERIFICAR SE A NOTA POSSUI ALGUM ANEXO
    /*this.verificaAnexo = function(){
        var widgetLiberacao = templateManager.container.getWidget('wdg_liberacaoParaFinanceiro');
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widgetLiberacao.currentRow.CDFILIAL
            },
            {
                "name": "NRLANCTONF",
                "operator": "=",
                "value": widgetLiberacao.currentRow.NRLANCTONF
            }
        ];
        
        
        var notas = widgetLiberacao.dataSource.data;
        notas.forEach(function(nota){
            var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": nota.CDFILIAL
                },
                {
                    "name": "NRLANCTONF",
                    "operator": "=",
                    "value": nota.NRLANCTONF
                }
            ];
            
            General.callRestEngine('df#/anexonfe', 'FilterData', filter).then(function(success) {
                if(success.dataset.anexonfe.length != 0){
                    nota.ANEXO = 'S';
                }else{
                    nota.ANEXO = 'N';
                }
            });
        });
        widgetLiberacao.dataSource.data = notas;
    };*/
    
    
    /*this.verificaOrcamento = function(){
        var widgetLiberacao = templateManager.container.getWidget('wdg_liberacaoParaFinanceiro');
        
        var notas = widgetLiberacao.dataSource.data;
        notas.forEach(function(nota){
            var filter = [
                {
                    "name": "P_CDFILIAL",
                    "operator": "=",
                    "value": nota.CDFILIAL
                },
                {
                    "name": "P_NRLANCTONF",
                    "operator": "=",
                    "value": nota.NRLANCTONF
                }
            ];
            nota.FORAORCAMENTO = false;
            General.callRestEngine('df_entrada#/crud/item_produtoCP', "FilterData", filter).then(function(success) {
                if(success.dataset.item_produtoCP.length != 0){
                    success.dataset.item_produtoCP.forEach(function(produto){
                        if(produto.VRSALDO < 0){
                            nota.FORAORCAMENTO = true;
                        }
                    });
                }
            });
        });
        widgetLiberacao.dataSource.data = notas;
    };*/
    
    
    this.cancelarAprovacao = function(widget, widgetJustificativa){
        
        //this.setAprovacaoLiberacao(widget, 'B');
        if(widgetJustificativa.isValid()) {
            var notasMarcadas = widget.getCheckedRows();
            var notas = notasMarcadas.filter(function(notafiscal){
                
                return notafiscal.IDSTATUS === "A" && notafiscal.IDBLOQNFFIN == "B";
            });
    
            //if(notas.length > 0){
                notas[0].DSOBSRECUSA = widgetJustificativa.currentRow.DSOBSRECUSA;
                
                AprovacaoLancamentos_Service.cancelarAprovacaoNotasMarcadas(notas).then(function(errosCancelamento){
                    widget.reload();
                    if(widget.name == 'wdg_liberacaoParaFinanceiro') 
                        widget.unSelectAll();
                    if(Object.keys(errosCancelamento.dataset.errosCancelamento).length > 0)
                        ErrosCancelamentoAprovacaoLancamentos_Utilities.errosCancelamento(widget, errosCancelamento.dataset.errosCancelamento);
                    else {
                        ScreenService.successNotification("Nota Fiscal recusada com sucesso!");
                        General.callRestEngine("df_entrada#/updateDsJustificativa", "DataSet", notas).then(function() {
                            localStorageEngine.getDataSource("df#/config_transmissao").then(function(transmissao){
                                var config = transmissao[0].config;
                                notas[0].CONFIG = config;
                                General.callRestEngine("df_entrada#/enviaEmailRecusa", "DataSet", notas).then(function() {
                                
                                });
                            });
                        });
                    }
                    
                }, requestError);
            //}else{
              //  ScreenService.showMessage("Nenhuma nota bloqueada foi marcada! ");
            //}
            
            widgetJustificativa.reload();
            widgetJustificativa.isVisible = false;
            ScreenService.closePopup(widgetJustificativa.name);
                
            widget.reload();
            ScreenService.closePopup();
        }
        
    };
    
    this.limpaCampo = function(widget){
        templateManager.container.getWidget('justificativaRecusa').currentRow.DSOBSRECUSA = null;
    };
    
    var requestError = function(error){
        var errorMessage = "Ocorreu um erro ao tentar realizar a operação.";
        if (error && error.data) {
            errorMessage = error.data.error;
        }
        ScreenService.showMessage(errorMessage, "ERROR");
    };
    
    
    this.carrega = function(){
        var filter = [
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": templateManager.container.getWidget('wdg_liberacaoParaFinanceiro').currentRow.CDFILIAL
            },
            {
                "name": "P_NRLANCTONF",
                "operator": "=",
                "value": templateManager.container.getWidget('wdg_liberacaoParaFinanceiro').currentRow.NRLANCTONF
            }
        ];
        General.callRestEngine("df_entrada#/crud/item_produtoCP", "FilterData", filter).then((success) => {
            if(success){
                 
            }
        });
    };
    
    this.setAprovacaoLiberacaoCP = function(widget, mode) {
        widget.reload().then(function(){
            
            var rows = widget.getCheckedRows();
            var nota = templateManager.container.getWidget('wdg_liberacaoParaFinanceiro').currentRow;
            templateManager.container.getWidget('wdg_liberacaoParaFinanceiro').reload();
            if(rows)  {
                var informacoes = [];
                informacoes[0] = rows;
                informacoes[1] = nota;
                rows.concat(nota);
                if(mode == 'L'){
                    General.callRestEngine("df_entrada#/liberarTitulosCP", "DataSet", informacoes).then((result) => {
                        var titulosLiberados = "TITULOS_LIBERADOS";
                        ScreenService.closePopup();
                        if(result.dataset.erros_aprovacao[0]) {
                            if(rows.length != result.dataset.erros_aprovacao.length) {
                                ScreenService.successNotification(result.messages[0].message);
                            }
                            this.openPopupErros(result.dataset.erros_aprovacao);
                        }
                        else {
                            if(result.messages[0].message == "Nenhum dos titulos selecionados pode ser liberado."){
                                ScreenService.showMessage("Nenhum dos titulos selecionados pode ser liberado.");
                            }else{
                                MessageService.successNotificationByCode(titulosLiberados, null, {"NUMTITULOS": result.messages[0].message});
                            }
                        }
                        widget.reload();
                        widget.getParent().reload();
                        templateManager.container.getWidget('wdg_liberacaoParaFinanceiro').reload();
                    }, (error) => ScreenService.errorNotification(error));
    
                }else{
                    General.callRestEngine("df_entrada#/bloquearTitulosCP", "DataSet", informacoes).then((result) => {
                        var titulosBloqueados = "TITULOS_BLOQUEADOS";
                        ScreenService.closePopup();
                        if(result.dataset.erros_aprovacao[0]) {
                            if(rows.length != result.dataset.erros_aprovacao.length) {
                                ScreenService.successNotification(result.messages[0].message);
                            }
                            this.openPopupErros(result.dataset.erros_aprovacao);
                        }
                        else {
                            if(result.messages[0].message == "Nenhum dos titulos selecionados pode ser bloqueado."){
                                ScreenService.showMessage("Nenhum dos titulos selecionados pode ser bloqueado.");
                            }else{
                                MessageService.successNotificationByCode(titulosBloqueados, null,{"NUMTITULOS": result.messages[0].message});                        
                            }
                        }
                    widget.reload();
                    widget.getParent().reload();
                    templateManager.container.getWidget('wdg_liberacaoParaFinanceiro').reload();
                }, (error) => ScreenService.errorNotification(error));
    
                }
            }
            else {
                ScreenService.showMessage("Nenhum titulo foi selecionado.");
            }
        });
    };
    
    this.openPopupErros = function(erros) {
        var widgetErros = templateManager.container.getWidget('WidgetErros');
        widgetErros.dataSource.data = erros;
        widgetErros.isVisible = true;
        ScreenService.openPopup(widgetErros);
        widgetErros.activate();
    };
    
    this.filtroPainelDeControle = function(args) {
        let CDEMPRESA =  sessionStorage.getItem('CDEMPRESA');
        let DTENTRSAID =  JSON.parse(sessionStorage.getItem('DTEMISSAO'));
        let LiberacaoParaFinanceiro = args.owner;
        
        let dataSourceFilter = [
            {"name":"CDEMPRESA","value":CDEMPRESA ,"operator":"="},
            {"name":"DTENTRSAID","value":[ DTENTRSAID.start, DTENTRSAID.end],"operator":"BETWEEN"},
            {"name":"TCDTIPOOPER","value":"T","operator":"="},
            {"name":"TCDFILIORIG","value":"T","operator":"="},
            {"name":"TCDSERIEENTR","value":"T","operator":"="},
            {"name":"ERRO","value":"T","operator":"="},
            {"name":"IDBLOQNFFIN","value":"T","operator":"="}
            ];
        LiberacaoParaFinanceiro.dataSourceFilter = dataSourceFilter;
        LiberacaoParaFinanceiro.reload().then(() => {
            LiberacaoParaFinanceiro.activate();
        });
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Dfe47000_LiberacaoParaFinanceiro_Controller", Dfe47000_LiberacaoParaFinanceiro_Controller);
}); 