var  Dfe43200_ParametrosDocumentosFiscaisSaida_Controller = function(Dfe43200_ParametrosDocumentosFiscaisSaida_Service, ScreenService, templateManager,General){

    this.editar = function(widget){
        widget.currentRow.senhaSMTPSaidaAlterada = false;
        widget.currentRow.senhaSMTPEntrAlterada = false;
        if(widget.name=='parametrosFilial'){
                var tabbedParametrosFilial =  templateManager.container.getWidget('tabbedParametrosFilial');
                tabbedParametrosFilial.getField('NMFILIAL').readOnly=true;
        }
        if(widget.name=='parametrosEmpresa'){
                var tabbedParametrosEmpresa =  templateManager.container.getWidget('tabbedParametrosEmpresa');
                tabbedParametrosEmpresa.getField('NMEMPRESA').readOnly=true;
        }
        widget.template = widget.templateToForm;
        General.edit(widget);
    };

    this.cancelar = function(widget){
        for (var i in widget.backupRow) {
			widget.currentRow[i] = widget.backupRow[i];
		}
		widget.template = widget.templateToView;
		widget.view();
		widget.activate();
		
        if(widget.name=='parametrosFilial'){
                var tabbedParametrosFilial =  templateManager.container.getWidget('tabbedParametrosFilial');
                tabbedParametrosFilial.getField('NMFILIAL').readOnly=false;
        }
        if(widget.name=='parametrosEmpresa'){
                var tabbedParametrosEmpresa =  templateManager.container.getWidget('tabbedParametrosEmpresa');
                tabbedParametrosEmpresa.getField('NMEMPRESA').readOnly=false;
        }
    };

    this.controlaStatusWidgets = function(mainWidget, nomeWidgetAtual, status){
        mainWidget.widgets.forEach(function(widg) {
            if(nomeWidgetAtual !== widg.name)
                widg.enabled = status;
        });

        if(mainWidget.name !== nomeWidgetAtual)
            mainWidget.enabled = status;
    };

    this.WidgetOnEnter = function(widget){
        widget.currentRow = widget.dataSource.data[0];
        if(widget.name=='parametrosGerais'){
            this.setarCampoEncargo(widget);
        }
    };
    
    this.enterInlineEditTipoOperacao = function(widget) {
        this.controlaStatusWidgets(widget.parent, "tipoOperacao", false);
    };
    
    this.exitInlineEditTipoOperacao = function(widget) {
        this.controlaStatusWidgets(widget.parent, "tipoOperacao", true);
    };
    
    this.cancelTipoOperacao = function(widget) {
        this.exitInlineEditTipoOperacao(widget);
        widget.reload();
        widget.list();
    };
    
    this.salvarTipoOperacao = function (widget) {
        var itens = widget.dataSource.data;
        var itensModificados = itens.filter(item => item.changed_IDUTILOPER);
        
        itensModificados.forEach (item => {
            item.changed = true;
        });
        
        widget.dataSource.save().then(function () {
            itensModificados.forEach (item => {
                //@todo remover delete item.changed quando desmarcaLinhasEditadas for implementada
                delete item.changed_IDUTILOPER;
                delete item.changed;
            });
            widget.activate();
            widget.list(true);
            ScreenService.successNotification("Parâmetros salvos com sucesso.");
        });
        
        this.exitInlineEditTipoOperacao(widget);
    };

    this.senhaSMTPAlterada = function(Widget){
    Widget.currentRow.senhaSMTPSaidaAlterada = true;
    };
    
    this.salvarParametrosGerais = function(args){
        var widget = args.owner.widget;
        
        if(widget.currentRow.IDBLAPRLCTMAPBL != "S"){
            widget.currentRow.IDBLAPRLCTMAPBL = "N";
        }
        
        if(widget.currentRow.IDUTTLSEMAILGSAID != "S"){
            widget.currentRow.IDUTTLSEMAILGSAID = "N";
        }
        
        if(widget.currentRow.IDUTSSLEMAILGSAID != "S"){
            widget.currentRow.IDUTSSLEMAILGSAID = "N";
        }
        
        if(widget.currentRow.IDUTTLSEMAILGENTR != "S"){
            widget.currentRow.IDUTTLSEMAILGENTR = "N";
        }
        
        if(widget.currentRow.IDUTSSLEMAILGENTR != "S"){
            widget.currentRow.IDUTSSLEMAILGENTR = "N";
        }
        
        if(widget.currentRow.NRDECITOTANF>2) {
            ScreenService.showMessage("Número de casas decimais de totalização deve estar entre 0 e 2.");
        }
        else if(widget.currentRow.NRDUPLINFS>100000){
            ScreenService.showMessage("Intervalo entre número de lançamentos para duplicações de notas fiscais deve estar ente 0 e 100000.");
        }
        else{
            if(widget.currentRow.CDENCDESCBONDEV==" "){
                widget.currentRow.CDENCDESCBONDEV=null;
            }
            General.saveCrud(widget).then(function() {
                this.controlaStatusWidgets( templateManager.container.getWidget('container_tabbed'),'parametrosGerais',true);
                var currentRow = widget.currentRow;
                currentRow.__is_new = false;
                currentRow.changed = false;
                widget.template = widget.templateToView;
                widget.view();
                ScreenService.closeSwipe();
                widget.reload();
                widget.list();
            }.bind(this), function(callback){
                ScreenService.showMessage(callback.data.error);

            });
        }
    };
    
    this.salvarSMTP = function(args){
        var widget = args.owner.widget;
        Dfe43200_ParametrosDocumentosFiscaisSaida_Service.salvarParametrosGerais(widget.currentRow).then(function() {  
            this.controlaStatusWidgets( templateManager.container.getWidget('container_tabbed'),'parametrosGerais',true);
                    var currentRow = widget.currentRow;
                    currentRow.__is_new = false;
                    currentRow.changed = false;
                    widget.template = widget.templateToView;
                    widget.view();
                    ScreenService.closeSwipe();
                    widget.reload();
                    widget.list();
               
        }.bind(this), function(callback){
                    ScreenService.showMessage(callback.data.error);
         });
    };


    this.setarCampoEncargo = function(widget){
        var cdEncargo = widget.dataSource.data[0].CDENCDESCBONDEV;
        var currentRow = widget.currentRow;
        if (cdEncargo){
            General.callRestEngine( "df#/crud/encargo", "FilterData", 
            [{name: "CDENCARGO", operator: "=", value: cdEncargo}]).then( (encargo) => {
                currentRow.NMENCARGO = encargo.dataset.encargo[0].NMENCARGO;
             });
        }
    };

    this.filtroParametrosFilial =  function(){
        var tabbedParametrosFilial =  templateManager.container.getWidget('tabbedParametrosFilial');
        var gridParametrosFilial =  templateManager.container.getWidget('parametrosFilial');
        var filial = tabbedParametrosFilial.getField('NMFILIAL').value();
        if(filial){
            gridParametrosFilial.getAction('editar').isVisible = true;
            gridParametrosFilial.reload();
        }else{
            gridParametrosFilial.getAction('editar').isVisible = false;
            for (let registro in gridParametrosFilial.currentRow) {
        		gridParametrosFilial.currentRow[registro] = '';
        	}
        }
        
    };

    this.verificaInsercaoFilial = function(){
        var tabbedParametrosFilial =  templateManager.container.getWidget('tabbedParametrosFilial');
        var gridParametrosFilial =  templateManager.container.getWidget('parametrosFilial');
        var filial =tabbedParametrosFilial.getField('CDFILIAL');
        if(filial.value()){
            var dataParametros = gridParametrosFilial.dataSource.data;
            //se não exister o parametros para filial cadastrado insere uma nova linha
            if(dataParametros.length==0){
                gridParametrosFilial.currentRow={};
                gridParametrosFilial.currentRow.CDFILIAL=filial.value();
                gridParametrosFilial.currentRow.__is_new=true;
                gridParametrosFilial.dataSource.name = "df#/crud/paramfilial";
                gridParametrosFilial.saveRow().then(function() {
                    gridParametrosFilial.dataSource.name = "df_saida#/paramfilial_saida";
                    gridParametrosFilial.reload();
                }.bind(this), function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                    gridParametrosFilial.dataSource.name = "df_saida#/paramfilial_saida";
                });

            }
        }
    };

    this.salvarParametrosFilial = function(args){
        var widget = args.owner.widget;
        if(widget.currentRow.NRTAMNUMNFUT>20){
            ScreenService.showMessage("Tamanho no Nº da Nota Fiscal deve estar entre 1 e 20");
        }
        else{
            widget.currentRow.DSPARFILFIS =  Dfe43200_ParametrosDocumentosFiscaisSaida_Service.concatenaCampoParametrosFilial(widget.currentRow);
            Dfe43200_ParametrosDocumentosFiscaisSaida_Service.salvarParametrosFilial(widget.currentRow).then(function() {
                this.controlaStatusWidgets( templateManager.container.getWidget('container_tabbed'),'tabbedParametrosFilial',true);
                var tabbedParametrosFilial =  templateManager.container.getWidget('tabbedParametrosFilial');
                tabbedParametrosFilial.getField('NMFILIAL').readOnly=false;
                var currentRow = widget.currentRow;
                currentRow.__is_new = false;
                currentRow.changed = false;
                widget.template = widget.templateToView;
                widget.view();
                ScreenService.closeSwipe();
                widget.reload();
                widget.list();
            }.bind(this), function(callback){
                ScreenService.showMessage(callback.data.error);

            });
        }
    };

    this.filtroParametrosEmpresa =  function(){
        var tabbedParametrosEmpresa =  templateManager.container.getWidget('tabbedParametrosEmpresa');
        var gridParametrosEmpresa =  templateManager.container.getWidget('parametrosEmpresa');
        var empresa = tabbedParametrosEmpresa.getField('CDEMPRESA').value();
        if(empresa){
            gridParametrosEmpresa.getAction('editar').isVisible = true;
            gridParametrosEmpresa.reload();
        }else{
            gridParametrosEmpresa.getAction('editar').isVisible = false;
            for (let registro in gridParametrosEmpresa.currentRow) {
        		gridParametrosEmpresa.currentRow[registro] = '';
        	}
        }
    };

    this.verificaInsercaoEmpresa = function(args){

        var tabbedParametrosEmpresa =  templateManager.container.getWidget('tabbedParametrosEmpresa');
        var gridParametrosEmpresa =  templateManager.container.getWidget('parametrosEmpresa');
        var empresa =tabbedParametrosEmpresa.getField('CDEMPRESA');
        if(empresa.value()){
            var dataParametros = gridParametrosEmpresa.dataSource.data;
            //se não exister o parametros para empresa cadastrado insere uma nova linha
            if(dataParametros.length==0){
                gridParametrosEmpresa.currentRow={};
                gridParametrosEmpresa.currentRow.CDEMPRESA=empresa.value();
                gridParametrosEmpresa.currentRow.__is_new=true;
                gridParametrosEmpresa.dataSource.name = "df#/crud/paramempresa";
                gridParametrosEmpresa.saveRow().then(function() {
                    gridParametrosEmpresa.dataSource.name = "df_saida#/paramempresa_saida";
                    gridParametrosEmpresa.reload();
                }.bind(this), function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                    gridParametrosEmpresa.dataSource.name = "df_saida#/paramempresa_saida";
                });

            }
        }
    };

    this.salvarParametrosEmpresa = function(args){
        var widget = args.owner.widget;
        General.saveCrud(widget).then(function() {
            this.controlaStatusWidgets( templateManager.container.getWidget('container_tabbed'),'tabbedParametrosEmpresa',true);
            var tabbedParametrosEmpresa =  templateManager.container.getWidget('tabbedParametrosEmpresa');
            tabbedParametrosEmpresa.getField('NMEMPRESA').readOnly=false;
            var currentRow = widget.currentRow;
            currentRow.__is_new = false;
            currentRow.changed = false;
            widget.template = widget.templateToView;
            widget.view();
            widget.reload();
            widget.list();
        }.bind(this), function(callback){
            if(callback.data !== undefined)
                ScreenService.showMessage(callback.data.error);
            else
                ScreenService.showMessage(callback);

        });
    };

    this.campoParametrosEmpresa = function(){
        var gridParametrosEmpresa =  templateManager.container.getWidget('parametrosEmpresa');
        var idt = gridParametrosEmpresa.getField('IDABATNFDNFOSA').value();

        if(idt=="S"){
            gridParametrosEmpresa.getField('CDAJUCTPAG').readOnly = false;
            gridParametrosEmpresa.getField('CDAJUCTPAG').validations.required = true;
            gridParametrosEmpresa.getField('CDAJUCTPAG').reload();

        }else{
            delete(gridParametrosEmpresa.getField('CDAJUCTPAG').validations.required );
            gridParametrosEmpresa.getField('CDAJUCTPAG').readOnly = true;
            gridParametrosEmpresa.getField('CDAJUCTPAG').value("");
            gridParametrosEmpresa.getField('DSAJUCTPAG').value("");
            gridParametrosEmpresa.getField('CDAJUCTPAG').reload();
        }
    };

    /*
    this.salvarOperadorLogistico = function(args){
        var Widget = args.owner.widget;
        General.saveCrud(Widget).then(function() {
            this.controlaStatusWidgets( templateManager.container.getWidget('container_tabbed'),'gridOperadorLogistico',true);
            var currentRow = Widget.currentRow;
            currentRow.__is_new = false;
            currentRow.changed = false;
            Widget.template = Widget.templateToView;
            Widget.view();
            Widget.reload();
            Widget.list();
        }.bind(this), function(callback){
            ScreenService.showMessage(callback.data.error);

        });
    };
    */
    this.recarregarWidget = function(nomeWidget){
        var widget =  templateManager.container.getWidget(nomeWidget);
        widget.reload();
    };

    this.salvar = function(args){
        var widget = args.owner.widget;
        General.saveCrud(widget).then(function() {
            this.controlaStatusWidgets( templateManager.container.getWidget('container_tabbed'),widget.name,true);
            var currentRow = widget.currentRow;
            currentRow.__is_new = false;
            currentRow.changed = false;
            widget.template = widget.templateToView;
            widget.view();
            widget.reload();
            widget.list();
        }.bind(this), function(callback){
            ScreenService.showMessage(callback.data.error);

        });
    };
    /*
    this.verficaUtilizaAlmoxarifado = function(args){
        var gridParametrosFilial =  templateManager.container.getWidget('parametrosFilial');
        if(gridParametrosFilial.currentRow.IDUTILALLONF=='S'){
            if(gridParametrosFilial.currentRow.IDUTILALMOX=='N'){
                ScreenService.showMessage('Unidade Não Utiliza Almoxarifado');
                gridParametrosFilial.getField('IDUTILALLONF').value('N');
            }
        }

    };

    this.situacaoCampoLancamentoManual = function(){
        var gridParametrosGerais =  templateManager.container.getWidget('parametrosGerais');
        var campoImportaXML= gridParametrosGerais.getField('IDTPIMPNFE');
        var campoLancamento =gridParametrosGerais.getField('IDPELANIMPXML');
        if(campoImportaXML.value()=="F"){
            campoLancamento.value("N");
            campoLancamento.readOnly=true;
        }else {
            campoLancamento.readOnly=false;
        }
    };


*/

    /* ************************** Parametros documentos Saida - Controle de Lançamento Retroativo ************************** */
    //pendente
    this.cancelaContrLancRetro = function(args){
        ScreenService.closePopup(args.owner.widget);  
    };
    
    this.openNumeracaoNota = function(args){
        ScreenService.openPopup(templateManager.container.getWidget("numeracaoNota"));  
    };
    //pendente
    this.gerarSenha = function(args){
        let widget = args.owner.widget;
        
        if(widget.isValid()){
            Dfe11000_LancamentoEntrada_Service.geraSenhaLancRetroativo(widget.currentRow).then( response => {
                widget.currentRow.SENHAGERADA = response.dataset.senha.SENHAGERADA;
            });
        }
    };
};
   



Configuration(function (ContextRegister){
    ContextRegister.register('Dfe43200_ParametrosDocumentosFiscaisSaida_Controller', Dfe43200_ParametrosDocumentosFiscaisSaida_Controller);
});