function Dfs85000_ManifestoDocumentoEletronico_Controller(Dfs85000_ManifestoDocumentoEletronico_Service, templateManager, General, ZhFilterPreferences, ScreenService, MessageService, ZHPromise) {
    
    let defaultMdfe = {
        CDEMPRESA: '',
        NMEMPRESA: '',
        CDINSCESTA: ''
    };
    
    let UP = 1;
    let DOWN = -1;
    
    this.setDefaultFilter = function(args) {
        var widget     = args.owner;
        var currentRow = widget.currentRow;
        var row        = { CDFILIAL: getLocalVar('CDFILIAL')};
        
        General.callRestEngine("df_entrada#/defaultFilterManif", "Row", row).then((defaultFilter) =>  {
            
            defaultFilter = defaultFilter.dataset.defaultFilter;
            var keys = ['CDEMPRESA', 'NMEMPRESA', 'NMRAZSOCEMPR', 'NRINSJURIEST', 'CDINSCESTA', 'DTEMISSAO'];
            var filter = Util.clone(currentRow, ["__rightActions", "__leftActions"]);
            keys.map((key) => {
                if(key == 'DTEMISSAO') {
                    filter.DTMDFE = {
                        start:  defaultFilter[key],
                        period: undefined,
                        end:    defaultFilter[key]
                    };
                }
                filter[key] = defaultFilter[key];
            });
            widget.getField('CDINSCESTA').readOnly = false;
            ZhFilterPreferences.setOriginalFilter(widget.id, filter);
            ZhFilterPreferences.openFilterWidget(widget, filter).then ( () => {
                var filterWidget = templateManager.container.getActiveWidget();
                filterWidget.actions.filter(action => action.name === "clear")[0].shortcutKey = "ctrl+backspace";
                filterWidget.getField('CDINSCESTA').readOnly = !filterWidget.currentRow.CDEMPRESA;
                filterWidget.getField("CDINSCESTA").dataSourceFilter[0].value = filterWidget.currentRow.CDEMPRESA;
            });
        },
        (error) => {
            ZhFilterPreferences.openFilterWidget(widget).then ( () => {
                var filterWidget = templateManager.container.getActiveWidget();
                filterWidget.actions.filter(action => action.name === "clear")[0].shortcutKey = "ctrl+backspace";
            });
        });
    };
    
    this.preparaFiltro = function(widget, args) {
        
        
        let currentRow = args.e.preference.FILTER_ROW;
        args.e.preventDefault();
        widget.dataSourceFilter = [];
        Dfs85000_ManifestoDocumentoEletronico_Service.buildFilter(["CDEMPRESA", "NRINSJURIEST", "CDINSCESTA", "CDVIATURA", "CDMOTORISTA", "NRMDFEINI", "NRMDFEFIN", "IDSTATUSMDFE", "IDTPAMBIENTEMDFE", "IDTIPOEMISMDFE"], currentRow, true)
        .then((filter) => {
            widget.dataSourceFilter = filter;

            widget.dataSourceFilter.push({name: "P_DTMDFEINI", operator: "=", value: currentRow.DTMDFE.start});
            widget.dataSourceFilter.push({name: "P_DTMDFEFIM", operator: "=", value: currentRow.DTMDFE.end});

            
            widget.reload().then(() => {
                widget.activate();
            });
            ScreenService.closePopup();
            
            defaultMdfe.CDEMPRESA   = currentRow.CDEMPRESA;
            defaultMdfe.CDINSCESTA  = currentRow.CDINSCESTA;
            defaultMdfe.NMEMPRESA   = currentRow.NMEMPRESA;
            
            var row = {CDEMPRESA: args.e.preference.FILTER_ROW.CDEMPRESA};
            General.callRestEngine("df_saida#/getDefaultMdfe", "Row", row).then((success) => {
                Dfs85000_ManifestoDocumentoEletronico_Service.setDefaultMdfe(success.dataset.mdfe);
            });
        });

    };
    
    this.controlaActionsMdfe = function(widget, actions) {
        var rowMdfe = templateManager.container.getWidget('manifesto_eletronico').currentRow;
        var readOnly = (rowMdfe.IDSTATUSMDFE == 'A' || rowMdfe.IDSTATUSMDFE == 'E' || rowMdfe.IDSTATUSMDFE == 'C');

        actions.forEach((actionName) => {
            var action = widget.getAction(actionName); 
            action.readOnly = readOnly; 
        });
    };
    
    this.controlaVisibiliadeCabecalho = function (widget) {
        var row = widget.currentRow;
        var status = row.IDSTATUSMDFE;
        
        var actionTransmitir = widget.getAction('actTransmitirMDFE');
        var actionCancelar   = widget.getAction('actCancelarMDFE');
        var actionEncerrar   = widget.getAction('actEncerrarMDFE');
        var actionConsulta   = widget.getAction('actConsultaMDFE');
        var actionDamdfe     = widget.getAction('actVisualizarDamdfe');
        
        let visibiltyTransmitir      = status == 'P' || status == 'R';
        let visibiltyCancelar        = status == 'A';
        let visiblityEncerrar        = status == 'A';
        let visibiltyConsultar       = true;
        let visibilityDamdfe         = status == 'A';
        
        actionTransmitir.isVisible = visibiltyTransmitir;
        actionCancelar.isVisible   = visibiltyCancelar;
        actionEncerrar.isVisible   = visiblityEncerrar;
        actionConsulta.isVisible   = visibiltyConsultar;
        actionDamdfe.isVisible     = visibilityDamdfe;
        
    };
    
    this.onChangeResponsavelSeguro = function(widget) {
        if(widget.currentRow.IDRESPSEGURO == '2') {
            widget.getField('NRINSJURRESP').validations     = {required: true};
            widget.getField('NRINSCSEGURADORA').validations = {required: true};
            widget.getField('NMSEGURADORA').validations     = {required: true};
            widget.getField('NRAPOLISE').validations        = {required: true};
            widget.getField('NRINSJURRESP').readOnly        = false;
            widget.currentRow.NRINSJURRESP = '';
        }  
        else {
            widget.getField('NRINSJURRESP').validations     = {required: true};
            widget.getField('NRINSCSEGURADORA').validations = {required: true};
            widget.getField('NMSEGURADORA').validations     = {required: true};
            widget.getField('NRAPOLISE').validations        = {};
            widget.getField('NRINSJURRESP').readOnly        = true;
            widget.currentRow.IDTPINSJURRESP = 'J';
            widget.currentRow.NRINSJURRESP = widget.getParent().currentRow.NRINSJURIEST;
            this.validaInscricaoResponsavel(widget.getField('NRINSJURRESP'));
        }
    };

    
    this.empresaOnChange = function(widget) {
        var activeWidget = templateManager.container.getActiveWidget();
        if (activeWidget.name == 'zhFilterPreferencesSelectConditions') {
            activeWidget.getField("CDINSCESTA").dataSourceFilter[0].value = activeWidget.currentRow.CDEMPRESA;
        }
        widget.currentRow.CDINSCESTA = '';
        if(!widget.currentRow.CDEMPRESA) {
            widget.getField('CDINSCESTA').readOnly = true;
        }
        else{
            widget.getField('CDINSCESTA').readOnly = false;
        }
        widget.getField('CDINSCESTA').reload();
    };
    
    this.novoMdfe = function(widget) {
        widget.newRow();
        let currentRow = widget.currentRow;   
        Dfs85000_ManifestoDocumentoEletronico_Service.getDefaultMdfe().then((defaultMdfe) => {
            currentRow = Object.assign(currentRow, defaultMdfe[0]);
            currentRow.__is_new = true;
            widget.getField('CDINSCESTA').reload();
            widget.getField('CDMODDOCFISCMDFE').setValue('58');
            currentRow.CDMODDOCFISCMDFE = '58';
            this.controlaStatusWidgets(widget, widget.name, false);
        });
    };
    
    this.salvarMDFE = function(widget) {
        widget.getField('CDMODDOCFISCMDFE').setValue('58');
        widget.currentRow.CDMODDOCFISCMDFE = '58';
        widget.currentRow.NRINSJURRESPGER = widget.currentRow.NRINSJURRESPGER.replace(/[^0-9]/g, '');
        if(widget.isValid()) {
            if(widget.currentRow.NRCIOT && !widget.currentRow.NRINSJURRESPGER) {
                MessageService.showMessageByCode("CIOT_SEM_INSCRICAO");
            }
            else if(!widget.currentRow.NRCIOT && widget.currentRow.NRINSJURRESPGER) {
                MessageService.showMessageByCode("INSCRICAO_SEM_CIOT");
            }
            else {
                if(widget.currentRow.NRINSJURRESPGER) {
                    if(widget.currentRow.NRINSJURRESPGER.length == 11 || widget.currentRow.NRINSJURRESPGER.length == 14) {
                        let objInscricao = General.inscricaoFormat(widget.currentRow.NRINSJURRESPGER);
                        if(objInscricao.valid) {
                            this.salvaMDFE(widget);
                        }
                        else {
                            MessageService.showMessageByCode("INSCRICAO_RESPONSAVEL_GERACAO_INVALIDA");
                        }
                    }
                    else {
                        MessageService.showMessageByCode("INSCRICAO_RESPONSAVEL_GERACAO_INVALIDA");
                    }
                }
                else {
                    this.salvaMDFE(widget);
                    
                }
            }
        }
    };
    
    this.salvarSeguroCarga = function(widget) {
        if(widget.isValid()) {
            widget.currentRow.NRINSJURRESP     = widget.currentRow.NRINSJURRESP.replace(/[^0-9]/g, '');
            widget.currentRow.NRINSCSEGURADORA = widget.currentRow.NRINSCSEGURADORA.replace(/[^0-9]/g, '');
            if(widget.currentRow.NRINSJURRESP.length == 11 || widget.currentRow.NRINSJURRESP.length == 14) {
                var objInscricao = General.inscricaoFormat(widget.currentRow.NRINSJURRESP);
                if(objInscricao.valid) {
                    if(widget.currentRow.NRINSCSEGURADORA) {
                        if(widget.currentRow.NRINSCSEGURADORA.length == 14) {
                            var objInscricaoSeg = General.inscricaoFormat(widget.currentRow.NRINSCSEGURADORA);
                            if(objInscricaoSeg.valid) {
                                General.callRestEngine("df#/salvaSeguroCarga", "Row", widget.currentRow).then((success) => {
                                    MessageService.successNotificationByCode("REGISTRO_SALVO");
                                    if(widget.currentRow.__is_new) {
                                        ScreenService.closeSwipe();
                                        widget.list();
                                    }
                                    else {
                                        widget.view();
                                    }
                                    this.controlaStatusWidgets(widget, widget, true);
                                    this.controlaStatusWidgets(widget.getParent(), widget, true);
                                    widget.reload();
                                }).catch((error) => {
                                    ScreenService.errorNotification(error.data.error);
                                });
                            }
                            else {
                                MessageService.showMessageByCode("INSCRICAO_SEGURADORA_SEGURO_INVALIDA");                                        
                            }
                        }
                        else {
                            MessageService.showMessageByCode("INSCRICAO_SEGURADORA_SEGURO_INVALIDA");                                            
                        }
                    }
                    else {
                        General.callRestEngine("df#/salvaSeguroCarga", "Row", widget.currentRow).then((success) => {
                            MessageService.successNotificationByCode("REGISTRO_SALVO");
                            if(widget.currentRow.__is_new) {
                                ScreenService.closeSwipe();
                                widget.list();
                            }
                            else {
                                widget.view();
                            }         
                            this.controlaStatusWidgets(widget, widget, true);
                            this.controlaStatusWidgets(widget.getParent(), widget, true);
                            widget.reload();
                        }).catch((error) => {
                            ScreenService.errorNotification(error.data.error);
                        });
                    }
                }
                else {
                    MessageService.showMessageByCode("INSCRICAO_RESPONSAVEL_SEGURO_INVALIDA");
                }
            }
            else {
                MessageService.showMessageByCode("INSCRICAO_RESPONSAVEL_SEGURO_INVALIDA");
            }
                
        }  
    };
    
    this.editarSeguroCarga = function (widget) {
        General.edit(widget);
        this.controlaStatusWidgets(widget, widget.name, false);
        
        var nrinsjurresp = widget.currentRow.NRINSJURRESP;
        this.onChangeResponsavelSeguro(widget);
        
        if (widget.currentRow.IDRESPSEGURO == '2') {
            widget.getField("NRINSJURRESP").setValue(nrinsjurresp);
        }
        this.validaInscricaoResponsavel(widget.getField("NRINSJURRESP"), "IDTPINSJURRESP");
        this.validaInscricaoResponsavel(widget.getField("NRINSCSEGURADORA"), "");
    };
    
    this.salvaMDFE = function(widget) {
        var widgetNotas = templateManager.container.getWidget('notasrelacionadas');
        widget.currentRow.NRINSJURRESPGER = widget.currentRow.NRINSJURRESPGER.replace(/[^0-9]/g, '');
        General.callRestEngine("df#/salvarMDFE", "Row", widget.currentRow).then((success) => {
            widget.currentRow.NRLANCTOMDFE = success.messages[0].message.NRLANCTOMDFE;
            this.controlaStatusWidgets(widget, widget.name, true);
            MessageService.successNotificationByCode("REGISTRO_SALVO");
            widget.view();
            this.controlaVisibiliadeCabecalho(widget);
            widget.reload();
            widgetNotas.activate();
        }).catch((error) => {
            ScreenService.errorNotification(error.data.error);
        });  
    };
    
    this.adicionarWidgetFilha = function(widget, otherFields = []) {
        widget.newRow();
        widget.currentRow.NRLANCTOMDFE = widget.getParent().currentRow.NRLANCTOMDFE;
        widget.currentRow.CDVIATURA    = widget.getParent().currentRow.CDVIATURA;
        otherFields.forEach((field) => {
            widget.currentRow[field] = widget.getParent().currentRow[field]; 
        });
        this.controlaStatusWidgets(widget.getParent(), widget, false, [widget.name]);
    };
    
    this.adicionarAverbacao = function(widget, otherFields = []) {
        widget.newRow();
        widget.currentRow.NRLANCTOMDFE = widget.getParent().currentRow.NRLANCTOMDFE;
        widget.currentRow.CDVIATURA    = widget.getParent().currentRow.CDVIATURA;
        otherFields.forEach((field) => {
            widget.currentRow[field] = widget.getParent().currentRow[field]; 
        });
    };
    
    this.salvarGenerico = function(widget, dataSourceName, controlaStatus = true, fechaAba = true) {
        var route = "df#/" + dataSourceName;
        var row = Util.clone(widget.currentRow, ["__rightActions", "__leftActions"]);
        
        if(!widget.isValid()) {
            return;
        }
        
        General.callRestEngine(route, "Row", row).then((success) => {
            if(controlaStatus)  this.controlaStatusWidgets(widget.getParent(), widget.name, true);
            MessageService.successNotificationByCode("REGISTRO_SALVO");
            if(widget.currentRow.__is_new) {
                if (fechaAba) {
                    ScreenService.closeSwipe();
                }
                widget.list();
            }
            else {
                widget.view();
            }
            widget.reload();
        }).catch((error) => {
            ScreenService.errorNotification(error.data.error);
        });  
    };
    
    this.excluirGenerico = function (widget, dataSourceName, checkedRows = false, closeSwipe = false) {
        var route = "df#/" + dataSourceName;
        var row = Util.clone(widget.currentRow, ["__rightActions", "__leftActions"]);
        var saveData;
        var requestType;
        var confirmCode;
        var sucessCode;
        
        if (checkedRows) {
            let rows = widget.getCheckedRows();
            rows.forEach (saveRow => {
                delete saveRow.__rightActions;
                delete saveRow.__leftActions;
            });
            saveData = rows;
            requestType = "DataSet";
            confirmCode = "REGISTRO_EXCLUIR_SELECIONADOS";
            sucessCode = "REGISTRO_EXCLUIDO_SELECIONADOS";
        }
        else {
            saveData = row;
            requestType = "Row";
            confirmCode = "REGISTRO_EXCLUIR";
            sucessCode = "REGISTRO_EXCLUIDO";
        }
        
        MessageService.confirmMessageByCode(confirmCode).then (sucess => {
            General.callRestEngine(route, requestType, saveData).then (response => {
                if (closeSwipe) {
                    ScreenService.closeSwipe();  
                }
                widget.reload();
                MessageService.successNotificationByCode(sucessCode);
            }).catch((error) => {
                ScreenService.showMessage(error.data.error);
            });
        });
        widget.reload();
    };
    
    this.adicionarNotaRelacionada = function (widget) {
        var widgetRelacionar = widget.container.getWidget('relacionarNotas');
        
        widgetRelacionar.dataSourceFilter = [
            {
                "name": "CDEMPRESA",
                "operator": "=",
                "value": "@General.getFieldValue('CDEMPRESA', 'manifesto_eletronico')@"
            },
            {
                "name": "CDINSCESTA",
                "operator": "=",
                "value": "@General.getFieldValue('CDINSCESTA', 'manifesto_eletronico')@"
            }];
        
        ScreenService.openPopup(widgetRelacionar);
        this.controlaStatusWidgets(widget.getParent(), widgetRelacionar.name, false);
        
        widgetRelacionar.reload();
    };
    
    this.confimarRelacionamentoNotas = function (widget) {
        var widgetNotasRelacionadas = widget.container.getWidget('notasrelacionadas');
        
        Dfs85000_ManifestoDocumentoEletronico_Service.saveNotasRelacionadas(widget).then(response => {
            ScreenService.closePopup();
            this.controlaStatusWidgets(widget.getParent(), widget.name, true);
            widgetNotasRelacionadas.reload();
        }).catch(error => {
            ScreenService.showMessage(error.data.error);
        });
    };
    
    this.mudarOrdemNotaMdfe = function (widget, sentido) {
        var row = Util.clone(widget.currentRow, ["__rightActions", "__leftActions"]);
        row.SENTIDO = sentido;
        General.callRestEngine("df#/notasRelacionadasMdfe/alterarOrdem", "Row", row).then (response => {
            widget.reload();
        }).catch((error) => {
            ScreenService.errorNotification(error.data.error);
        });
    };
    
    this.percursoFieldOnChange = function (fieldChanged) {
        var widget = fieldChanged.widget;
        var fieldPais = widget.getField("NMPAIS");
        var fieldEstado = widget.getField("NMESTADO");
        var fieldMunicipio = widget.getField("NMMUNICIPIO");
        
        if (fieldChanged === fieldPais) {
            widget.currentRow.SGESTADO = "";
            widget.currentRow.NMESTADO = "";
            widget.currentRow.CDMUNICIPIO = "";
            widget.currentRow.NMMUNICIPIO = "";
        }
        else if (fieldChanged === fieldEstado) {
            widget.currentRow.CDMUNICIPIO = "";
            widget.currentRow.NMMUNICIPIO = "";
        }
        
        var pais = fieldPais.value();
        var estado = fieldEstado.value();
        var municipio = fieldMunicipio.value();
        
        if (!pais) {
            widget.currentRow.SGESTADO = "";
            widget.currentRow.NMESTADO = "";
            widget.currentRow.CDMUNICIPIO = "";
            widget.currentRow.NMMUNICIPIO = "";
            fieldEstado.readOnly = true;
            fieldMunicipio.readOnly = true;
            return;
        }
        
        if (!estado) {
            widget.currentRow.CDMUNICIPIO = "";
            widget.currentRow.NMMUNICIPIO = "";
            fieldEstado.readOnly = false;
            fieldMunicipio.readOnly = true;
            return;
        }
        
        fieldEstado.readOnly = false;
        fieldMunicipio.readOnly = false;
    };
    
    this.mudarOrdemPercursoMdfe = function (widget, sentido) {
        var row = Util.clone(widget.currentRow, ["__rightActions", "__leftActions"]);
        row.SENTIDO = sentido;
        General.callRestEngine("df#/percursoMdfe/alterarOrdem", "Row", row).then (response => {
            widget.reload();
        }).catch((error) => {
            ScreenService.errorNotification(error.data.error);
        });
    };
    
    this.buildFilterTransmissao = function (currentRow) {
        var row = JSON.parse(JSON.stringify(currentRow)); //Cria uma cópia
        
        var promise = ZHPromise.defer();
        
        for (let rowName in row) {
            if (['CDMOTORISTA', 'CDVIATURA'].includes(rowName)) {
                row[rowName] = [row[rowName]];
            }
        }
        
        row.IDSTATUSMDFE = '';
        row.IDTPAMBIENTEMDFE = '';
        row.IDTIPOEMISMDFE = '';
        row.CDMOTORISTA = '';
        
        Dfs85000_ManifestoDocumentoEletronico_Service.buildFilter(["CDEMPRESA", "NRINSJURIEST", "CDINSCESTA", "CDVIATURA", "CDMOTORISTA", "NRMDFEINI", "NRMDFEFIN", "IDSTATUSMDFE", "IDTPAMBIENTEMDFE", "IDTIPOEMISMDFE"], row, true)
        .then((filter) => {
          //  console.log(row);
            filter.push({name: "P_DTMDFEINI", operator: "=", value: moment(currentRow.DTMDFE, "DD/MM/YYYY hh:mm:ss").subtract(1, "days").format("DD/M/YYYY")});
            filter.push({name: "P_DTMDFEFIM", operator: "=", value: moment(currentRow.DTMDFE, "DD/MM/YYYY hh:mm:ss").add(1, "days").format("DD/M/YYYY")});
            filter.push({name: "NRLANCTOMDFE", operator: "=", value: currentRow.NRLANCTOMDFE});
            //console.log(filter);
            promise.resolve(filter);
        });
        
        return promise;
    };
    
    this.reloadRowMdfe = function (widget, filter) {
        var deffered = ZHPromise.defer();
        General.callRestEngine("df#/crud/mdfe_emissao", "FilterData", filter).then (response => {
            if (!response.dataset.mdfe_emissao.length) {
                return;
            }
            widget.currentRow = response.dataset.mdfe_emissao[0];
            for (var key in widget.dataSource.data) {
                if (widget.dataSource.data[key].NRLANCTOMDFE == widget.currentRow.NRLANCTOMDFE) {
                    widget.dataSource.data[key] = widget.currentRow;
                }
            }
            widget.reload();
            this.controlaVisibiliadeCabecalho(widget);
        });
        return deffered;
    };
    
    this.acaoMdfeSefaz = function (widget, route, message, cancelamento = false) {
        var self = this;
        var currentRow = widget.currentRow;
        route = "df#/" + route;
        
        if (!widget.isValid()) {
            return;
        }
    
        this.buildFilterTransmissao(currentRow).then((filter) => {
            if (cancelamento) {
                filter.push({name: "MOTCANCELA", operator: "=", value: currentRow.MOTCANCELA});
                if (currentRow.MOTCANCELA.length < 15) {
                    MessageService.showMessageByCode("MDFE_CANCELA_MENSAGEM_CURTA");
                    return;
                }
            }
            MessageService.confirmMessageByCode(message).then (success => {
                General.callRestEngine(route, "FilterData", filter).then (response => {
                    if (cancelamento) {
                        this.controlaStatusWidgets(widget.getParent(), widget.name, true);
                        ScreenService.closePopup();
                        widget = widget.getParent();
                    }
                    if (response.messages) {
                        var resposta = response.messages[0].message;
                        if (resposta.isError) {
                            MessageService.showMessageByCode(resposta.message, {"PARAMETRO" : resposta.motivo});
                        }
                        else {
                            MessageService.showMessageByCode(resposta.message);
                        }
                    }
                    else {
                        ScreenService.showMessage(response);
                    }
                    
                    self.reloadRowMdfe(widget, filter);
                    ScreenService.closePopup();
                }).catch((error) => {
                    self.reloadRowMdfe(widget, filter);
                    ScreenService.showMessage(error.data.error);
                    ScreenService.closePopup();
                });
            });
        });
    };
    
    this.cancelarMdfe = function (widget) {
        var widgetCancelamento = widget.container.getWidget('cancelamento');
        
        widgetCancelamento.currentRow = widget.currentRow;
        
        ScreenService.openPopup(widgetCancelamento);
        this.controlaStatusWidgets(widget.getParent(), widgetCancelamento.name, false);
        
        widgetCancelamento.reload();
    };
    
    this.visualizarDamdfe = function (widget) {
        var currentRow = widget.currentRow;
    
        this.buildFilterTransmissao(currentRow).then((filter) => {
                General.callRestEngine("df#/downloadDamdfe", "FilterData", filter).then (response => {
                    response.dataset.downloadDamdfe.forEach (fileUri => {
                        this.downloadArquivo(fileUri);
                    });
                }).catch((error) => {
                    ScreenService.showMessage(error.data.error);
                });
        });
        
    };
    
    /** 
     * Funções Gerais
     */
     this.controlaStatusWidgets = function(widgetPai, nomeWidgetAtual, status, ignoredWidgets) {
        var allWidgets = widgetPai.widgets;

        allWidgets.filter(widget => widget.name !== nomeWidgetAtual).forEach(widget => widget.enabled = status);

        if (widgetPai.name !== nomeWidgetAtual)
            widgetPai.enabled = status;

        if (Array.isArray(ignoredWidgets))
            allWidgets.filter(widget => ignoredWidgets.indexOf(widget.name) !== -1).forEach(widget => widget.enabled = !status);
    };
    
    this.validaInscricaoResponsavel = function(field, nmFieldTpInsc) {
        var value = field.value();
        if (!value) {
            return;
        }
        let obj = General.inscricaoFormat(value);
        var inscricoesValidas;
        if (nmFieldTpInsc) {
            inscricoesValidas = ["J", "F"];
        }
        else {
            inscricoesValidas = ["J"];
        }
        
        if(!obj.valid || !inscricoesValidas.includes(obj.tipo.cod)) {
            field.setValue('');
            if(nmFieldTpInsc) {
                field.widget.currentRow[nmFieldTpInsc] = '';
                switch (nmFieldTpInsc) {
                    case 'IDTPINSJURRESPGER': MessageService.showMessageByCode("INSCRICAO_SEGURADORA_SEGURO_INVALIDA"); break;
                    case 'IDTPINSJURRESP'   : MessageService.showMessageByCode("INSCRICAO_RESPONSAVEL_GERACAO_INVALIDA"); break;
                }
            }
            else {
                MessageService.showMessageByCode("INSCRICAO_RESPONSAVEL_SEGURO_INVALIDA");
            }
        }
        else {
            field.setValue(obj.value);
            field.widget.reload();
            if(nmFieldTpInsc) {
                field.widget.currentRow[nmFieldTpInsc] = obj.tipo.cod;
            }
        }
    };
    
    this.downloadArquivo = function(nmArquivo){
        window.open(window.serviceUrls.filter(function(x){return x.package == 'df';})[0].baseUrl+"/downloadArquivo?requestType=Row&row[DSARQUIVO]=" + nmArquivo);
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register("Dfs85000_ManifestoDocumentoEletronico_Controller", Dfs85000_ManifestoDocumentoEletronico_Controller);
});
