var Dfs99500_TipoDeOperacao_X_Filial_Controller = function(MessageService, ZhFilterPreferences, ScreenService, templateManager, General) {
    
    var routes = {
        "insert_filial": "df#/tipooperac_filial/insert",
        "insert_cliente": "df#/tipooperac_cliente/insert",
        "delete_cliente": "df#/tipooperac_cliente/remove",
        "get_endereco": "df#/tipooperac_endereco/get",
        "put_endereco": "df#/tipooperac_filial/put"
    };
    
    this.openFilterWidget = function(widget, defaultFilter){
        ZhFilterPreferences.openFilterWidget(widget, defaultFilter).then(response => {
            var filter = templateManager.container.getActiveWidget();
            var clearFilter = filter.actions.filter(action => action.name === 'clear')[0];
            var confirmFilter = filter.actions.filter(action => action.name === 'never')[0];
            
            clearFilter.shortcutKey = 'ctrl+backspace';
            clearFilter.tooltip = 'Limpar Filtro (CTRL + Backspace)';
            
            confirmFilter.shortcutKey = 'ctrl + enter';
            filter.reload();
            
        });
    };
    
    var controlaStatusWidgets = function(status) {
        var parentWidget = templateManager.container.getWidget("tipoOperac");
        var widgetAtiva = templateManager.container.getActiveWidget();
        widgetAtiva.enabled = true;

        if (parentWidget.name !== widgetAtiva.name)
            parentWidget.enabled = status;

    };
    
    this.controlaStatusWidgets = function(status) {
        var parentWidget = templateManager.container.getWidget("tipoOperac");
        var widgetAtiva = templateManager.container.getActiveWidget();
        widgetAtiva.enabled = true;

        if (parentWidget.name !== widgetAtiva.name)
            parentWidget.enabled = status;

    };
    
    this.editTipoOperac = function(widget) {
        var parentWidget = templateManager.container.getWidget("tipoOperac");
        widget.edit();
        parentWidget.backupRow = Util.clone(parentWidget.currentRow);
    };
    
    this.deleteTipoOperac = function(parentWidget) {
        MessageService.confirmMessageByCode("REGISTRO_EXCLUIR").then( () => {
            parentWidget.removeRow().then(function () {
                parentWidget.reload();
                ScreenService.closeSwipe().then(function () {
                    parentWidget.activate();
                });
            }, function (error) {
                if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                    ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                } else {
                    ScreenService.showMessage(error.data.error);
                }
            });
        });
    };
    
    this.cancelEdit = function(args) {
        var parentWidget = templateManager.container.getWidget("tipoOperac");
        General.backOrCancel(args);
        controlaStatusWidgets(true);
        General.changeWidgetAcessibility(parentWidget.widgets, true);
    };
    
    var applyDefaultValues = function(parentWidget) {
        parentWidget.widgets.forEach(function(childWidget) {
            childWidget.fields.forEach(function(field) {
                field.applyDefaultValue();
            });
        });
    };
    
    this.newRow = function(widget) {
        General.changeWidgetAcessibility(widget.widgets, false);
        widget.newRow();
        this.setWidgetsCurrentRow(widget);
        applyDefaultValues(widget);
    };
    
    //checkbox
    this.controlaWidgets = function(mainWidget, nomeWidgetAtual, status){
        mainWidget.widgets.forEach(function(widg) {
            if(nomeWidgetAtual !== widg.name)
                widg.enabled = status;
        });

        if(mainWidget.name !== nomeWidgetAtual)
            mainWidget.enabled = status;
    };
    
    this.enterInlineEditTipoOperacao = function(widget) {
        this.controlaWidgets(widget.parent, "tipoOperac", false);
    };
    
    this.exitInlineEditTipoOperacao = function(widget) {
        this.controlaWidgets(widget.parent, "tipoOperac", true);
    };
    
    this.salvarTipoOperacao = function (widget) {
        var itens = widget.dataSource.data;
        var itensModificados = itens.filter(item => item.changed_IDLIBERADO || item.changed_IDLANCMANUAL);
        
        itensModificados.forEach (item => {
            item.changed = true;
            item.SYSDATE = moment();
        });
        
        
        //General.callRestEngine("nome_rota", "requestType", "parameters")
        General.callRestEngine("df#/tipooperac_filial/put", "Row", itensModificados).then(response => {
            widget.activate();
            widget.list(true);
            recarregarWidget(widget.name);
        });
        
        
        this.exitInlineEditTipoOperacao(widget);
        
    };
    
    this.cancelTipoOperacao = function(widget) {
        this.exitInlineEditTipoOperacao(widget);
        widget.reload();
        widget.list();
    };
    
    this.setWidgetsCurrentRow = function(parentWidget) {
        parentWidget.widgets.forEach(function(childWidget) {
            childWidget.currentRow = parentWidget.currentRow;
        });
    };
    
    var recarregarWidget = function(nomeWidget){
        var widget =  templateManager.container.getWidget(nomeWidget);
        widget.reload();
    };
    
    this.onLoadDataSource = function(widget) {
        var filter = templateManager.container.getActiveWidget();
    };

    this.setDefaultIdEntradaSaida = function(widget) {
        widget.currentRow.IDENTRSAIDOP = "S";
        var filter = templateManager.container.getActiveWidget();
        filter.reload();
    };
    
    this.add_containerTabbed = (args, isFilial) =>{
        var widget_active = [];
        
        if(isFilial){
            widget_active = this.getWidgetPai_filial();
            if(widget_active.appliedFilter){
                this.openWidgetAdd();
            }else{
                return MessageService.showMessageByCode('filtrar_antes');
            }
        }else{
            widget_active = this.getWidgetPai_cliente();
            if(widget_active.appliedFilter){
                this.openWidgetAddCliente();
            }else{
                return MessageService.showMessageByCode('filtrar_antes');
            }
        }
    };
    
    this.edit_containerTabbed = (args) =>{
        this.openWidgetEdit();
    };
    
    this.getWidgetEdit  = () => { 
        if(templateManager.container)
            return templateManager.container.getWidget("editContainer");
    };
    
    this.getWidgetAdd  = () => { 
        if(templateManager.container)
            return templateManager.container.getWidget("addContainer");
    };
    
    this.getWidgetEndereco  = () => {
        if(templateManager.container)
            return templateManager.container.getWidget("widget_endereco");
    };
    
    this.getWidgetPai_filial  = () => { 
        if(templateManager.container)
            return templateManager.container.getWidget("tipoOperac");
    };
    
    this.getWidgetPai_cliente  = () => { 
        if(templateManager.container)
            return templateManager.container.getWidget("tipoOperac_cliente");
    };
    
    this.getWidgetPai_endereco  = () => { 
        if(templateManager.container)
            return templateManager.container.getWidget("tipoOperac_endereco");
    };
    
    this.openWidgetEdit      = () => {
        var widget          = this.getWidgetEdit();
        widget.isVisible    = true;
        ScreenService.openPopup(widget);
        widget.activate();
        this.setEnderecoFields(widget);
    };
    
    this.openWidgetAdd      = () => {
        var widget          = this.getWidgetAdd();
        widget.isVisible    = true;
        ScreenService.openPopup(widget);
        widget.activate();
        this.setDefaultFields(true, widget);
        this.setNeedFields(true, widget);
    };
    
    this.openWidgetAddCliente = () => {
        var widget          = this.getWidgetAdd();
        widget.isVisible    = true;
        ScreenService.openPopup(widget);
        widget.activate();
        this.setDefaultFields(false, widget);
        this.setNeedFields(false, widget);
    };
    
    this.setEnderecoFields = (widget) => {
        var widget_pai = this.getWidgetPai_filial(),
            filter_active = widget_pai.appliedFilter.FILTER_ROW;
            
            widget.currentRow.CDFILIAL = filter_active.CDFILIAL;
            widget.currentRow.NMFILIAL = filter_active.NMFILIAL;
            widget.currentRow.IDENDEMISTPOPFIL = widget_pai.currentRow.IDENDEMISTPOPFIL;
            widget.currentRow.CDTIPOOPER = widget_pai.currentRow.CDTIPOOPER;
            
    };
    
    this.setDefaultFields = (isFilial, widget) => {
        var widget_active,
            filter_active,
            widget_add = this.getWidgetAdd();
            
        if(isFilial){
            widget_add.isFilial = true;
            widget_active = this.getWidgetPai_filial();
            filter_active = widget_active.appliedFilter.FILTER_ROW;
            
            widget.currentRow.CDFILIAL = filter_active.CDFILIAL;
            widget.currentRow.NMFILIAL = filter_active.NMFILIAL;
        }else{
                widget_add.isFilial = false;
                widget_active = this.getWidgetPai_cliente();
                filter_active = widget_active.appliedFilter.FILTER_ROW;
                
                widget.currentRow.CDFILIAL  = filter_active.CDFILIAL;
                widget.currentRow.NMFILIAL  = filter_active.NMFILIAL;
                widget.currentRow.CDCLIENTE     = filter_active.CDCLIENTE;
                widget.currentRow.NMRAZSOCCLIE  = filter_active.NMRAZSOCCLIE;
        }
        
    };
    
    this.setNeedFields = (isFilial, widget) => {
        var arrayFieldsFilial  = [];
        var arrayFieldsCliente = [];
        
        arrayFieldsFilial.push(widget.getField("IDLIBERADO"));
        arrayFieldsFilial.push(widget.getField("IDLANCMANUAL"));
        arrayFieldsCliente.push(widget.getField("NMRAZSOCCLIE"));
        
        
        if(isFilial){
            arrayFieldsFilial.forEach(field => {
                field.showOnList = true;
                field.showOnForm = true;
                field.isVisible = true;
            });
            arrayFieldsCliente.forEach(field => {
                field.showOnList = false;
                field.showOnForm = false;
                field.isVisible = false;
            });
            
        }else{
            arrayFieldsFilial.forEach(field => {
                field.showOnList = false;
                field.showOnForm = false;
                field.isVisible = false;
            });
            arrayFieldsCliente.forEach(field => {
                field.showOnList = true;
                field.showOnForm = true;
                field.isVisible = true;
            });
        }
    };
    
    this.actVoltar      = function(args) {
        var widget = args.owner.widget;
        General.backOrCancel(args);
        widget.reload();
    };
    
    this.limpaFieldsEdit     = (widget) => {
        widget.fields.forEach(field => {
            field.setValue('');
        });
    };
    
    var callCloseWidgetAdd = () =>{
        this.closeWidgetAdd();
    };
    
    this.closeWidgetAdd     = () => {
        var widgetOwner      = templateManager.container.getWidget("container_tabbed");
        var widget           = templateManager.container.getWidget("addContainer");
        
        this.limpaFieldsEdit(widget); 
        
        widget.reload();
        widget.isVisible     = false;
        ScreenService.closePopup('editCode');
        
        widgetOwner.isVisible = true;
        widgetOwner.activate();
        widgetOwner.reload();
        
    };
    
    this.getInsert = (args) => {
        var widget_addContainer = this.getWidgetAdd();
        
        if(widget_addContainer.isFilial === true){
            this.insert(templateManager.container.getWidget("tipoOperac"), templateManager.container.getWidget("addContainer"), routes.insert_filial, this.getWidgetAdd().currentRow);
        }else{
            this.insert(templateManager.container.getWidget("tipoOperac_cliente"), templateManager.container.getWidget("addContainer"), routes.insert_cliente, this.getWidgetAdd().currentRow);
        }
    };
    
    this.insert = (widget_pai, widget_addContainer, route, currentRow) => {
        let hasEqual = this.validaTipoOperUtilizado(widget_pai, widget_addContainer);
        if(hasEqual){
            if(widget_pai.isFilial == true){
                return MessageService.showMessageByCode('tipoOp_ja_cadastrado_filial');
            }else{
                return MessageService.showMessageByCode('tipoOp_ja_cadastrado_cliente');
            }
        }else{
            General.callRestEngine(route, "Row", [currentRow]).then(response => {
                callCloseWidgetAdd();
                widget_pai.reload();
            });
        }
    };
    
    this.validaTipoOperUtilizado = (widgetTipooperac, widgetAdd) => {
        var isEqual = false;
        widgetTipooperac.dataSource.data.forEach(TipoOplancado => {
            if(TipoOplancado.CDTIPOOPER ==  widgetAdd.currentRow.CDTIPOOPER){
                isEqual = true;
            }
        });
        return isEqual;
    };
    
    this.setDatasourceFilter = (args) => {
        //tirar mascara
        var widgetAtiva = args.owner.field.widgetAtiva;
        
        switch(widgetAtiva){
            case (1):
                let wdg_filial = this.getWidgetPai_filial();
                wdg_filial.dataSourceFilter = [{"name": "P_CDFILIAL","operator": "=",  "value": args.row.CDFILIAL }];
                break;
            case (2):
                let wdg_cliente = this.getWidgetPai_cliente();
                wdg_cliente.dataSourceFilter = [{"name": "P_CDFILIAL","operator": "=",  "value": args.row.CDFILIAL},
                                            {"name": "P_CDFORNCLIE", "operator": "=",  "value": args.row.CDCLIENTE}];
                break;
            default:
                console.log("Erro no setDatasourceFilter");
                break;
        }
        
    };
    
    this.getEndereco = (args) => {
        
        // General.callRestEngine(routes.get_endereco, "Row", this.getWidgetPai_endereco().currentRow).then(response => {
        //     let get_endereco = this.getWidgetEndereco();
        //     get_endereco.currentRow = response.dataset.Get.success;
        // });
        
        General.callRestEngine(routes.get_endereco, "Row", this.getWidgetEdit().currentRow).then(response => {
            let get_endereco = this.getWidgetEdit();
            let enderecoField = get_endereco.currentRow.IDENDEMISTPOPFIL;
            
            get_endereco.currentRow = response.dataset.Get.success;
            
            get_endereco.currentRow.IDENDEMISTPOPFIL = enderecoField;
        });
    };
    
    this.deleteTipoOperCliente = (widget) => {
        
        this.setDefaultFields(false, widget);
        
        General.callRestEngine(routes.delete_cliente, "Row", this.getWidgetPai_cliente().currentRow).then(response => {
            callCloseWidgetAdd();
            widget.reload();
        });
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Dfs99500_TipoDeOperacao_X_Filial_Controller", Dfs99500_TipoDeOperacao_X_Filial_Controller);
});