var dfs49000_TransmissaoNfe_Service = function(localStorageEngine, Dfs49000_TransmissaoNfe_Repositories) {
    this.montaConfigTransmissao = function(row){
        return Dfs49000_TransmissaoNfe_Repositories.montaConfigTransmissao(row);
    };
    
    this.buscaOperadorLogado = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": "OPERADOR_LOGADO"
            }
        ];

        return localStorageEngine.download("df#/crud/operador", filter);
    };
    
    // Função que contém lista dos parâmetros gerais de Pedido que vem para este módulo
    this.getParamsOutModule = function() {
        
        var params = ['PED_CDFILIAL','PED_CDEMPRESA','PED_NRINSJURNF','PED_IDORIGDESTNF','PED_IDSTATUSNFE','PED_VRNOTAFISC'];
        
        return params;
        
    };
    
    // Função que retorna todas as variaveis de Pedido que ficam na cache
    this.getLocalVarsFilterOutModule = function() {
        
        var localVars = {};
        
        var params = this.getParamsOutModule();
        
        localVars.DTENTRSAID = {};
        
        localVars.DTENTRSAID.start = localStorageEngine.getLocalVar('PED_DTENTRSAID.start');
        localVars.DTENTRSAID.end = localStorageEngine.getLocalVar('PED_DTENTRSAID.end');
        
        params.forEach(function(param){
            
            localVars[param.substring(4,param.length)] = localStorageEngine.getLocalVar(param);
            
        });
        
        return localVars;
        
    };
    
    // Função que apaga todas as variaveis de PEDIDO que ficam na cache
    this.clearLocalVarsOutModule = function() {
        
        var params = this.getParamsOutModule();
        
        localStorage.removeItem('PED_DTENTRSAID.start');
        localStorage.removeItem('PED_DTENTRSAID.end');
        
        params.forEach(function(param){
            
            localStorage.removeItem(param);
            
        });
        
    };
    
    this.buscaDataProcessamento = function(filial) {
        return Dfs49000_TransmissaoNfe_Repositories.retornaDataProcessamento(filial);
    };

    this.statusServico = function(notasfiscais){
        return getDataSourceConfigTransmissao().then(function(config){
            return Dfs49000_TransmissaoNfe_Repositories.statusServico(notasfiscais, config);
        });
    };

    this.transmiteNotas = function(notasfiscais, tipo){
        return getDataSourceConfigTransmissao().then(function(config){
            return Dfs49000_TransmissaoNfe_Repositories.transmiteNotas(notasfiscais, config, tipo);
        });
    };

    this.atualizaLote = function(lotesMarcados){
        return getDataSourceConfigTransmissao().then(function(config){
            return Dfs49000_TransmissaoNfe_Repositories.atualizaLote(lotesMarcados, config);
        });
    };

    this.cancelarTransmissao = function(row){
        return getDataSourceConfigTransmissao().then(function(config){
            return Dfs49000_TransmissaoNfe_Repositories.cancelarTransmissao(row, config);
        });
    };
    
    this.verificaParamintegra = function(row){
        return Dfs49000_TransmissaoNfe_Repositories.verificaParamintegra(row);
    };
    
    this.enviarCartaCorrecao = function(notafiscal, dscorrecaonfe, nrseqcce){
        return getDataSourceConfigTransmissao().then(function(config){
            return Dfs49000_TransmissaoNfe_Repositories.enviarCartaCorrecao(notafiscal, dscorrecaonfe, nrseqcce, config);
        });
    };

    this.visualizarDanfe = function(nota){
        return getDataSourceConfigTransmissao().then(function(config){
            return Dfs49000_TransmissaoNfe_Repositories.visualizarDanfe(nota, config);
        });
    };

    this.downloadDanfe = function(notasMarcadas){
        return getDataSourceConfigTransmissao().then(function(config){
            return Dfs49000_TransmissaoNfe_Repositories.downloadDanfe(notasMarcadas, config);
        });
    };

    this.downloadXML = function(nota){
        return getDataSourceConfigTransmissao().then(function(config){
            return Dfs49000_TransmissaoNfe_Repositories.downloadXML(nota, config);
        });
    };

    this.enviarEmailPendenteNFsAceitas = function(notas){
        return getDataSourceConfigTransmissao().then(function(config){
            return Dfs49000_TransmissaoNfe_Repositories.enviarEmailPendenteNFsAceitas(notas, config);
        });
    };

    this.enviarEmailNF = function(nota, tipo){
        return getDataSourceConfigTransmissao().then(function(config){
            return Dfs49000_TransmissaoNfe_Repositories.enviarEmailNF(nota, config, tipo);
        });
    };
    
    this.enviarEmailCC = function(nota, nrseqcce, tipo){
        return getDataSourceConfigTransmissao().then(function(config){
            return Dfs49000_TransmissaoNfe_Repositories.enviarEmailCC(nota, config, tipo, nrseqcce);
        });
    };

    this.alteraDataEmissao = function(row) {
        return Dfs49000_TransmissaoNfe_Repositories.alteraDataEmissao(row);
    };

    this.getProxSeqProdRural = function(data) {
        var maxSeqProdRural = 0;
        if(data.length){
            data.forEach(function(row){
                if(row.NRSEQPRODRURAL > maxSeqProdRural)
                    maxSeqProdRural = row.NRSEQPRODRURAL;
            });
        }
        return maxSeqProdRural + 1;
    };

    this.getProxSeqCartaCorrecao = function(data) {
        var maxSeqProdRural = 0;
        if(data.length){
            data.forEach(function(row){
                if(row.NRSEQPRODRURAL > maxSeqProdRural)
                    maxSeqProdRural = row.NRSEQPRODRURAL;
            });
        }
        return maxSeqProdRural + 1;
    };

    this.salvaProdutorRural = function(row) {
        return Dfs49000_TransmissaoNfe_Repositories.salvaProdutorRural(row);
    };

    this.excluirProdutorRural = function(row) {
        return Dfs49000_TransmissaoNfe_Repositories.excluirProdutorRural(row);
    };

    this.getConfig = function() {
        return getDataSourceConfigTransmissao();  
    };

    var getDataSourceConfigTransmissao = function() {
        return localStorageEngine.getDataSource("df#/config_transmissao").then(function(transmissao){
            return transmissao[0].config;
        });
    };

    this.getMaxNrseqcce = function(filial, lancamento){
        return Dfs49000_TransmissaoNfe_Repositories.getMaxNrseqcce(filial, lancamento);
    };
    
    this.requestModulesMetadata = () => {
        return Dfs49000_TransmissaoNfe_Repositories.requestModulesMetadata();
    };
    
    this.aprovarNotasTransmissao = (notas) => {
        return Dfs49000_TransmissaoNfe_Repositories.aprovarNotasTransmissao(notas);
    };
    
    this.emailAutomaticoTransmissao = (notas, config) => {
        return Dfs49000_TransmissaoNfe_Repositories.emailAutomaticoTransmissao(notas, config);
    };
    
    this.errosNotasTransmissao = (erros) => {
        let arrayErros = [];
        
        for(let i in erros) {
            arrayErros[i] = {CDFILIAL:      erros[i].CDFILIAL,
                             NRLANCTONF:    erros[i].NRLANCTONF,
                             IDENTRSAIDOP:  erros[i].IDENTRSAIDOP,
                             NRORG:         erros[i].NRORG,
                             TPERRO:        erros[i].TPERRO};
            
            if(Array.isArray(erros[i].DSERRO)) {
                for(let index in erros[i].DSERRO) {
                    if(erros[i].DSERRO[index].DSERRO) {
                        arrayErros[i].DSERRO = erros[i].DSERRO[index].DSERRO; //Retorna apenas o primeiro erro encontrado do lançamento.
                        break;
                    }
                }
            }
            else arrayErros[i].DSERRO = erros[i].DSERRO;
        }
        return arrayErros;
    };
    
    this.consultaSituacaoNF = (row, config) => {
        return Dfs49000_TransmissaoNfe_Repositories.consultaSituacaoNF(row, config);
    };
    
    this.setTipoTransmissao = (type) => {
        localStorageEngine.setDataSource("df_saida#/tipo_transmissao", {type});
    };
    
    this.getTipoTransmissao = () => {
        return localStorageEngine.getDataSource("df_saida#/tipo_transmissao").then(success => {
            return success.length ? success[0].type : success[0];
        });
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Dfs49000_TransmissaoNfe_Service", dfs49000_TransmissaoNfe_Service);
});