package com.javaseleniumtemplate.flows;

import com.javaseleniumtemplate.pages.LancamentoEntradaPages;
import static com.javaseleniumtemplate.GlobalParameters.DATA_VALIDADE;

public class LancamentoEntradaFlows {

    LancamentoEntradaPages lancamentoEntradaPages;

    public LancamentoEntradaFlows(){
        lancamentoEntradaPages = new LancamentoEntradaPages();
    }
    public void aplicarFiltro (){
        lancamentoEntradaPages.clicarAplicarFiltro();
    }
    public void adicionarLancamento(){
        lancamentoEntradaPages.clicarAdicionarLancamento();
    }
    public void salvarLancEntrada(){
        lancamentoEntradaPages.clicarSalvarLancEntrada();
    }
    public void clicarConfirmar(){lancamentoEntradaPages.clicarConfirmarInfoComplementar();}
    public void confirmar(){lancamentoEntradaPages.clicarConfirmar();}
    public void confirmarRelac(){lancamentoEntradaPages.clicarConfirmarRelac();}

    public void relacionaProdutoUm(String procuraRelacionamento){
        lancamentoEntradaPages.relacionarItemUm();
        lancamentoEntradaPages.editarRelacionamentoProduto();
        lancamentoEntradaPages.procuraProdutoImportar(procuraRelacionamento);
        lancamentoEntradaPages.selecionaProdutoField(); //HELA
        lancamentoEntradaPages.clicarSalvarLancRelacionamento();
        lancamentoEntradaPages.clicarVoltarTela();
    }
    public void relacionaProdutoDois(String procuraRelacionamento){
        lancamentoEntradaPages.relacionarItemDois();
        lancamentoEntradaPages.editarRelacionamentoProduto();
        lancamentoEntradaPages.procuraProdutoImportar(procuraRelacionamento);
        lancamentoEntradaPages.selecionaProdutoField();
        lancamentoEntradaPages.clicarSalvarLancRelacionamento();
        lancamentoEntradaPages.clicarVoltarTela();
    }
    public void relacionaProdutoTres(String procuraRelacionamentoTres){
        lancamentoEntradaPages.relacionarItemTres();
        lancamentoEntradaPages.editarRelacionamentoProduto();
        lancamentoEntradaPages.procuraProdutoImportar(procuraRelacionamentoTres);
        lancamentoEntradaPages.selecionaProdutoTresField();
        lancamentoEntradaPages.clicarSalvarLancRelacionamento();
        lancamentoEntradaPages.clicarVoltarTela();
    }
    /*public void relacionaProdutoQuatro(String procuraRelacionamento){
        lancamentoEntradaPages.relacionarItemUm();
        lancamentoEntradaPages.editarRelacionamentoProduto();
        lancamentoEntradaPages.procuraProdutoImportar(procuraRelacionamento);
        lancamentoEntradaPages.selecionaProdutoQuatroField();
        lancamentoEntradaPages.clicarSalvarLancRelacionamento();
        lancamentoEntradaPages.clicarVoltarTela();
    }*/

    public void editaVencimento(String vencimento){
        lancamentoEntradaPages.clicaVencimento();
        lancamentoEntradaPages.selecionaVencimento();
        lancamentoEntradaPages.clicarEditarVencimento();
        lancamentoEntradaPages.apagarVencimento();
        lancamentoEntradaPages.clicarVencimento();
        lancamentoEntradaPages.digitarVencimento(vencimento);
        lancamentoEntradaPages.salvarVencimento();
    }
    public void fechaNotaFiscal(){
        lancamentoEntradaPages.fecharNF();
        lancamentoEntradaPages.clicarConfirmaFechamento();
        lancamentoEntradaPages.popUpClicarEmOK();
        lancamentoEntradaPages.tabMensagemFechamento();
        lancamentoEntradaPages.clicarConfirmaFechamento();
    }
    public void fecharNotaFiscal(){
        lancamentoEntradaPages.fecharNF();
        lancamentoEntradaPages.clicarConfirmaFechamento();
    }
    public void filtroRelacionamentoProdXProdXml(String fornecedor){
        lancamentoEntradaPages.searchRelacProdForn(fornecedor);
        lancamentoEntradaPages.selecionaFornecedorRelac();
        lancamentoEntradaPages.clickAplicarFiltro();
    }
    public void aprovarNotaEntrada(){
        lancamentoEntradaPages.marcarCheckBoxAprovacao();
        lancamentoEntradaPages.clicarAprovacao();
        lancamentoEntradaPages.confirmaAprovacao();
    }
    public void desaprovarNotaEntrada(){
        lancamentoEntradaPages.marcarCheckBoxAprovacao();
        lancamentoEntradaPages.cancelarAprovacao();
    }
    public void preencheProdutoGelf(String quantidade, String valorUnitario){
        lancamentoEntradaPages.clicarAdicionarLancamento();
        lancamentoEntradaPages.clicarFieldProduto();
        lancamentoEntradaPages.selecionaProdutoGelf();
        lancamentoEntradaPages.infoComplementarProd(DATA_VALIDADE);
        lancamentoEntradaPages.clicarConfirmar();
        lancamentoEntradaPages.popupNao(); // memorizar data
        lancamentoEntradaPages.clicarQuantidadeField(quantidade);
        lancamentoEntradaPages.clicarVrUnitario();
        lancamentoEntradaPages.informaVrUnitario(valorUnitario);
        lancamentoEntradaPages.salvarProd();
    }
    public void preencheProdutoGelfSemControleDeEstoque(String quantidade, String valorUnitario){
        lancamentoEntradaPages.clicarAdicionarLancamento();
        lancamentoEntradaPages.clicarFieldProduto();
        lancamentoEntradaPages.selecionaProdutoGelf();
        lancamentoEntradaPages.clicarQuantidadeField(quantidade);
        lancamentoEntradaPages.clicarVrUnitario();
        lancamentoEntradaPages.informaVrUnitario(valorUnitario);
        lancamentoEntradaPages.salvarProd();
    }
    public void preencheProdutoAgua(String produto, String quantidade, String valorUnitario){
        lancamentoEntradaPages.clicarAdicionarLancamento();
        lancamentoEntradaPages.clicarFieldProdutoAgua();
        lancamentoEntradaPages.procuraProduto(produto);
        lancamentoEntradaPages.selecionaProdutoAgua();
        lancamentoEntradaPages.clicarQuantidadeField(quantidade);
        lancamentoEntradaPages.clicarVrUnitario();
        lancamentoEntradaPages.informaVrUnitario(valorUnitario);
        lancamentoEntradaPages.salvarProd();
    }
    public void preencheProdutoAguaNaoMemoriza(String produto, String quantidade, String valorUnitario){
        lancamentoEntradaPages.clicarAdicionarLancamento();
        lancamentoEntradaPages.clicarFieldProdutoAgua();
        lancamentoEntradaPages.procuraProduto(produto);
        lancamentoEntradaPages.selecionaProdutoAgua();
        lancamentoEntradaPages.clicarQuantidadeField(quantidade);
        lancamentoEntradaPages.clicarVrUnitario();
        lancamentoEntradaPages.informaVrUnitario(valorUnitario);
        lancamentoEntradaPages.salvarProd();
    }
    public void preencheProdutoAguaSanitaria(String produto, String quantidade, String valorUnitario) {
        lancamentoEntradaPages.clicarAdicionarLancamento();
        lancamentoEntradaPages.clicarFieldProdutoAgua();
        lancamentoEntradaPages.procuraProduto(produto);
        lancamentoEntradaPages.selecionaProdutoAguaSanitaria();
        lancamentoEntradaPages.clicarQuantidadeField(quantidade);
        lancamentoEntradaPages.clicarVrUnitario();
        lancamentoEntradaPages.informaVrUnitario(valorUnitario);
        lancamentoEntradaPages.salvarProd();
    }
    public void preencheProdutoEstoqueAgua(String produto){
        lancamentoEntradaPages.clicarAdicionarLancamento();
        lancamentoEntradaPages.clicarFieldProdutoAgua();
        lancamentoEntradaPages.procuraProduto(produto);
        lancamentoEntradaPages.selecionaProdutoEstoqueAgua();
    }
    public void preencheProdutoEstoqueHela(String produto){
        lancamentoEntradaPages.clicarFieldProdutoAgua();
        lancamentoEntradaPages.procuraProduto(produto);
        lancamentoEntradaPages.selecionaProdutoEstoqueHela();
    }
    public void preencheProdutoCompraPa(String produto){
        lancamentoEntradaPages.clicarFieldProduto();
        lancamentoEntradaPages.procuraProduto(produto);
        lancamentoEntradaPages.selecionaProdutoCompraPa();
    }
    public void preencheProdutoCompraCebola(String produto){
        lancamentoEntradaPages.clicarFieldProduto();
        lancamentoEntradaPages.procuraProduto(produto);
        lancamentoEntradaPages.selecionaProdutoCompraCebola();
    }
    public void preencheProdutoHelaOx(String quantidade, String valorUnitario){
        lancamentoEntradaPages.selecionaProdutoHelaOx(); // HelaOx
        lancamentoEntradaPages.clicarQuantidadeField(quantidade);
        lancamentoEntradaPages.clicarVrUnitario();
        lancamentoEntradaPages.informaVrUnitario(valorUnitario);
        lancamentoEntradaPages.salvarProd();
    }
    public void preencheProdutoHummer(String quantidade, String valorUnitario){
        lancamentoEntradaPages.selecionaProdutoHummer(); //Hummer
        lancamentoEntradaPages.clicarQuantidadeField(quantidade);
        lancamentoEntradaPages.clicarVrUnitario();
        lancamentoEntradaPages.informaVrUnitario(valorUnitario);
        lancamentoEntradaPages.salvarProd();
    }

    public void preencheDadosProduto(String quantidade, String valorUnitario){
        lancamentoEntradaPages.clicarConfirmar();
        lancamentoEntradaPages.popupNao(); // memorizar data
        lancamentoEntradaPages.clicarQuantidadeField(quantidade);
        lancamentoEntradaPages.clicarVrUnitario();
        lancamentoEntradaPages.informaVrUnitario(valorUnitario);
        lancamentoEntradaPages.salvarProd();
    }

    public void preencheDadosProdutoSemlote(String quantidade, String valorUnitario){
        lancamentoEntradaPages.clicarConfirmar();
        lancamentoEntradaPages.clicarQuantidadeField(quantidade);
        lancamentoEntradaPages.clicarVrUnitario();
        lancamentoEntradaPages.informaVrUnitario(valorUnitario);
        lancamentoEntradaPages.salvarProd();
    }
    public void preencheNotaFiscalEntrada(String remetente, String numero, String valor){
        lancamentoEntradaPages.clicaRemetenteNfEntrada();
        lancamentoEntradaPages.procuraRemetenteNfEntrada(remetente);
        lancamentoEntradaPages.selecionaRemetenteNfEntrada();
        lancamentoEntradaPages.clicaNumeroField();
        lancamentoEntradaPages.informaNumero(numero);
        lancamentoEntradaPages.clicaSerie();
        lancamentoEntradaPages.selecionaSerie();
        lancamentoEntradaPages.preencheValor(valor);
        lancamentoEntradaPages.clicarSalvarLancEntrada();
    }
    public void rastreabilidade(){
        lancamentoEntradaPages.infoComplementarProd(DATA_VALIDADE);
        lancamentoEntradaPages.clicarConfirmar();
        lancamentoEntradaPages.popupNao(); // memorizar data
        lancamentoEntradaPages.rastreabilidadeHela();
        lancamentoEntradaPages.infoComplementarProd(DATA_VALIDADE);
        lancamentoEntradaPages.clicarConfirmar();
        lancamentoEntradaPages.popupNao(); // memorizar data
        lancamentoEntradaPages.rastreabilidadeGeflu();
        lancamentoEntradaPages.infoComplementarProd(DATA_VALIDADE);
        lancamentoEntradaPages.clicarConfirmar();
        lancamentoEntradaPages.popupNao(); // memorizar data
    }
    public void preencherQuantEValorMultiplosProdutos(String quantProd, String valorUnitario, String quantProd2, String quantProd3){
        lancamentoEntradaPages.campoQuantProd(quantProd);
        lancamentoEntradaPages.campoVrUnitProd(valorUnitario);
        lancamentoEntradaPages.campoQuantProd2(quantProd2);
        lancamentoEntradaPages.campoVrUnitProd2(valorUnitario);
        lancamentoEntradaPages.campoQuantProd3(quantProd3);
        lancamentoEntradaPages.campoVrUnitProd3(valorUnitario);
        lancamentoEntradaPages.salvarProduto();
    }

    public void preencheDataValidade(){
        lancamentoEntradaPages.infoComplementarProd(DATA_VALIDADE);
    }

}