package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class LoginPage extends PageBase {
    //Mapping
    By usernameField = By.id("USER");
    By passwordField = By.id("PASSWORD");
    By loginButton = By.id("SUBMIT");
    By mensagemErroTextArea = By.xpath("//*[@class='zh-text-alert']");
    By mensagemAlert = By.xpath("//*[@class='zh-alert-button horizontal'][1]");
    By mensagemAlert2 = By.xpath("//*[@class='zh-alert-button']");
    By loadingWait = By.xpath("//*[@class='zh-background-loading ng-scope']//span[@class='zh-loading-icon']");
    By loadingWait2 = By.xpath("//div[@class='zh-position-loading']");

    //Actions
    public void preenhcerUsuario(String usuario){
        waitForInvisibilityOfElementLocated(loadingWait2);
        //click(usernameField);
        sendKeys(usernameField, usuario);
    }
    public void preencherSenha(String senha){
        sendKeys(passwordField, senha);
    }
    public void clicarEmLogin(){
        click(loginButton);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void aceitarMensagemAlerta(){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(mensagemAlert);
    }
    public void aceitarMensagemAlerta2(){
        click(mensagemAlert2);
    }
    public String retornaMensagemDeErro(){
        return getText(mensagemErroTextArea);
    }
}
